package com.zfire.mall.manager.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;

/**
 *直调发货
 */
@ApiModel
@Data
public class DirectOrderBean {
    @NotNull
    @ApiModelProperty("发货日期")
    private Date orderDate;
    @NotBlank
    @ApiModelProperty("发货仓库ID")
    private String correspondId;
    @NotBlank
    @ApiModelProperty("仓位ID")
    private String stockId;
    @NotNull
    @ApiModelProperty("直调发货明细")
    private List<DirectItem> directItems;
    @ApiModelProperty("单号(零售订单id或者工程订单id)")
    private String orderNo;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModel
    @Data
    public static class DirectItem{
        @ApiModelProperty("明细id")
        private String itemId;
        @ApiModelProperty("直调数量")
        private Integer qty;
    }


}
