package com.zfire.mall.manager.bean.config;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author qinrongjun
 * @description
 * @date 2023/7/26 11:17 星期三
 */
@Data
public class FirstPartyCustomerManagementAddParam {

    @ApiModelProperty(value = "甲方客户名称")
    @Length(max = 100, message = "甲方客户名称最大长度为100")
    @NotBlank(message = "甲方客户名称不能为空")
    private String name;

    @ApiModelProperty(value = "上级客户")
    @Length(max = 100, message = "上级客户最大长度为100")
    private String parentName;

    @ApiModelProperty(value = "客户规模")
    @Length(max = 20, message = "客户规模最大长度为20")
    @NotBlank(message = "客户规模不能为空")
    private String scale;

    @ApiModelProperty(value = "客户类型")
    @Length(max = 20, message = "客户类型最大长度为20")
    @NotBlank(message = "客户类型不能为空")
    private String type;

    @ApiModelProperty(value = "行业大类")
    @Length(max = 20, message = "行业大类最大长度为20")
    @NotBlank(message = "行业大类不能为空")
    private String tradeParentId;

    @ApiModelProperty(value = "行业小类")
    @Length(max = 20, message = "行业小类最大长度为20")
    @NotBlank(message = "行业小类不能为空")
    private String tradeId;

    @ApiModelProperty(value = "省id")
    @NotNull(message = "省不能为空")
    private Long provinceRegionId;

    @ApiModelProperty(value = "市id")
    @NotNull(message = "市不能为空")
    private Long cityRegionId;

    @ApiModelProperty(value = "区id")
    @NotNull(message = "区不能为空")
    private Long areaId;

    @ApiModelProperty(value = "详细地址")
    @Length(max = 100, message = "详细地址最大长度为100")
    @NotBlank(message = "详细地址不能为空")
    private String address;

    @ApiModelProperty(value = "客户关系")
    @Length(max = 20, message = "客户关系最大长度为20")
    @NotBlank(message = "客户关系不能为空")
    private String rela;

    @ApiModelProperty(value = "客户来源")
    @Length(max = 20, message = "客户来源最大长度为20")
    @NotBlank(message = "客户来源不能为空")
    private String resource;

    @ApiModelProperty(value = "联系人名称")
    @Length(max = 20, message = "联系人名称最大长度为20")
    @NotBlank(message = "联系人名称不能为空")
    private String linkName;

    @ApiModelProperty(value = "联系人职务")
    @Length(max = 20, message = "联系人职务最大长度为20")
    private String linkJob;

    @ApiModelProperty(value = "联系人部门")
    @Length(max = 20, message = "联系人部门最大长度为20")
    private String linkDepartment;

    @ApiModelProperty(value = "微信")
    @Length(max = 50, message = "微信最大长度为50")
    private String weXin;

    @ApiModelProperty(value = "联系人角色")
    @Length(max = 20, message = "联系人角色最大长度为20")
    private String linkRole;

    @ApiModelProperty(value = "邮箱")
    @Length(max = 50, message = "邮箱最大长度为50")
    private String email;

    @ApiModelProperty(value = "QQ")
    @Length(max = 50, message = "QQ最大长度为50")
    private String qq;
}
