package com.zfire.mall.manager.bean.config;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;

/**
 * @author qinrongjun
 * @description
 * @date 2023/7/26 11:02 星期三
 */
@Data
public class MerchantLoginQuotaLimitEditParam {

    @NotBlank(message = "id不能为空")
    @Length(max = 50, message = "id最大长度为50")
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "商家信息")
    @Length(max = 50, message = "商家信息id最大长度为64")
    private String customerId;

    @ApiModelProperty(value = "商家编号")
    @Length(max = 50, message = "商家编号最大长度为50")
    private String customerNumber;

    @ApiModelProperty(value = "工装登录名额限制")
    @Min(value = 0,message = "工装登录名额限制最小为0")
    private Integer workLoginLimit;

    @ApiModelProperty(value = "家装登录名额限制")
    @Min(value = 0,message = "家装登录名额限制最小为0")
    private Integer homeLoginLimit;

    @ApiModelProperty(value = "跨区登录名额限制")
    @Min(value = 0,message = "跨区登录名额限制最小为0")
    private Integer spanLoginLimit;

    @ApiModelProperty(value = "启用状态")
    private Boolean state;
}
