package com.zfire.mall.manager.bean.config;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;

/**
 * @author qinrongjun
 * @description
 * @date 2023/7/26 13:50 星期三
 */

@Data
public class TradeConfigEditParam {

    @NotBlank(message = "id不能为空")
    @Length(max = 50, message = "id最大长度为50")
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "分类名称")
    @Length(max = 50, message = "分类名称最大长度为50")
    private String name;

    @ApiModelProperty(value = "上级id, 为空或者0既是顶级")
    @Length(max = 50, message = "上级id最大长度为50")
    private String parentId;

    @ApiModelProperty(value = "状态 true=启用 false=停用")
    private Boolean state;

}
