package com.zfire.mall.manager.bean.config;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.Min;

/**
 * @author qinrongjun
 * @description
 * @date 2023/7/26 16:55 星期三
 */
@Data
public class TradeConfigListParam {
    @ApiModelProperty("分类名称搜索")
    @Length(max = 50, message = "最大长度为50")
    private String keyword;

    @ApiModelProperty("父级id, 为空或者0既是查询顶级")
    @Length(max = 50, message = "最大长度为50")
    private String parentId;

    @ApiModelProperty("第几页")
    @Min(value = 1, message = "页数最小为1")
    private Long pageNum;

    @ApiModelProperty("页大小")
    private Long pageSize;
}
