package com.zfire.mall.manager.bean.direct;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel
@Data
public class DirectTransferList {

    @ApiModelProperty("发货单号")
    private String deliverNo;
    @ApiModelProperty("发货日期")
    private String deliverDate;
    @ApiModelProperty("仓库名称")
    private String correspondName;
    @ApiModelProperty("订单类型 TRADE=商用 HOME=家用 RETAIL=零售单 RETAIL_POLICY 销售政策单")
    private String orderType;
    @ApiModelProperty("订单号")
    private String orderNo;
    @ApiModelProperty("经销商名称")
    private String customerName;
    @ApiModelProperty("产品名")
    private String materialName;
    @ApiModelProperty("规格型号")
    private String specification;
    @ApiModelProperty("计量单位")
    private String unit;
    @ApiModelProperty("单价")
    private BigDecimal price;
    @ApiModelProperty("直调数量")
    private Integer qty;
    @ApiModelProperty("价税合计")
    private BigDecimal mustTotalAmount;
    @ApiModelProperty("无税单价")
    private BigDecimal afterTaxPrice;
    @ApiModelProperty("无税金额")
    private BigDecimal noTaxTotalAmount;
    @ApiModelProperty("单个商品的押金金额")
    private BigDecimal singleDepositAmount;
    @ApiModelProperty("总押金金额")
    private BigDecimal totalDepositAmount;
    @ApiModelProperty("备注")
    private String remark;
    @ApiModelProperty("制表人")
    private String createBy;
    @ApiModelProperty("制表日期")
    private Date createTime;

}
