package com.zfire.mall.manager.bean.displace.order;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
public class DisplaceOrderInfo {

    @ApiModelProperty(value = "置换单编号")
    private String displaceOrderId;

    @ApiModelProperty(value = "订单日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date orderDate;

    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "金蝶物料编码")
    private String materialNumber;

    @ApiModelProperty(value = "金蝶物料名称")
    private String materialName;

    @ApiModelProperty(value = "金蝶物料旧编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ApiModelProperty(value = "单价")
    private BigDecimal price = new BigDecimal("0");

    @ApiModelProperty(value = "数量")
    private Integer qty = 0;

    @ApiModelProperty(value = "总押金金额")
    private BigDecimal totalDepositAmount;
}
