package com.zfire.mall.manager.bean.displace.order;

import com.zfire.mall.manager.plus.entity.DisplaceOrder;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
@ApiModel
public class DisplaceOrderListBean extends DisplaceOrder {

    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;

    @ApiModelProperty(value = "销售类型编码")
    private String saleTypeCode;

    @ApiModelProperty(value = "销售类型名称")
    private String saleTypeName;

    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "金蝶物料名称")
    private String materialName;

    @ApiModelProperty(value = "金蝶物料编码")
    private String materialNumber;

    @ApiModelProperty(value = "金蝶物料旧编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ApiModelProperty(value = "基本单位编码")
    private String unit;

    @ApiModelProperty(value = "单价")
    private BigDecimal price;

    @ApiModelProperty(value = "数量")
    private Integer qty;

    @ApiModelProperty(value = "折扣金额")
    private BigDecimal discAmount;

    @ApiModelProperty(value = "总折扣金额")
    private BigDecimal totalDiscAmount;

    @ApiModelProperty(value = "订单金额")
    private BigDecimal totalAmount;

    @ApiModelProperty(value = "返利钱包的返利比例")
    private BigDecimal rebateRate;

    @ApiModelProperty(value = "返利金额")
    private BigDecimal rebateAmount;

    @ApiModelProperty(value = "押金比例")
    private BigDecimal depositRate;

    @ApiModelProperty(value = "经销商现金钱包id")
    private String customerWalletId;

    @ApiModelProperty(value = "经销商现金钱包名称")
    private String customerWalletName;

    @ApiModelProperty(value = "经销商返利钱包id")
    private String customerWalletId2;

    @ApiModelProperty(value = "经销商返利钱包名称")
    private String customerWalletName2;

    @ApiModelProperty(value = "单个商品的返利金额(实际扣除的返利金额/qty)")
    private BigDecimal singleRebateAmount;

    @ApiModelProperty(value = "单个商品的实际支付金额(实际支付金额/qty)")
    private BigDecimal singlePayPrice;

    @ApiModelProperty(value = "单个商品的押金金额(单个商品的实际支付金额*押金比例)")
    private BigDecimal singleDepositAmount;

    @ApiModelProperty(value = "实付金额(订单金额-返利金额-折扣金额-不够扣的返利金额)")
    private BigDecimal payAmount;

    @ApiModelProperty(value = "实际扣除的返利金额")
    private BigDecimal payRebateAmount;

    @ApiModelProperty(value = "总押金金额")
    private BigDecimal totalDepositAmount;

    @ApiModelProperty(value = "税率例如: 0.13")
    private BigDecimal tax;

    @ApiModelProperty(value = "已发货数量")
    private Integer hasSendQty;

    @ApiModelProperty(value = "可退数量")
    private Integer refundableQty;

    @ApiModelProperty(value = "已退数量")
    private Integer retiredQty;
}
