package com.zfire.mall.manager.bean.engin.deposit;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "CustomerEnginDeposit对象", description = "经销商工程机押金比例配置")
public class CustomerEnginDeposit extends Model<CustomerEnginDeposit> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "帐号id")
    private String adminUserId;

    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "押金比例 例如： 0.1 非百分比")
    private BigDecimal rate;

    @ApiModelProperty(value = "定额押金")
    private BigDecimal amount;

    @ApiModelProperty(value = "开始时间")
    private Date startTime;

    @ApiModelProperty(value = "结束时间")
    private Date endTime;

    @ApiModelProperty(value = "备注")
    private String remark;

    private String adminCompanyId;

    @TableField(fill = FieldFill.DEFAULT)
    private Date createTime;

    @TableField(fill = FieldFill.DEFAULT)
    private String createBy;

    @TableField(fill = FieldFill.UPDATE)
    private Date updateTime;

    @TableField(fill = FieldFill.UPDATE)
    private String updateBy;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }
}

