package com.zfire.mall.manager.bean.engin.v2.info;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.IsEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
public class EnginInfoSaleExecVO {

    @ZfireField(tbName = "c")
    @ApiModelProperty("信息单日期")
    private Date orderDate;

    @ZfireField(tbName = "a")
    @ApiModelProperty("工程登录编号")
    private String refEnginRecordNo;

    @ZfireField(tbName = "c")
    @ApiModelProperty("经销商编码")
    private String customerNumber;

    @ZfireField(tbName = "c")
    @ApiModelProperty("经销商名称")
    private String customerName;

    @ZfireField(tbName = "a")
    @ApiModelProperty("项目名称")
    private String refProjectName;

    @ZfireField(tbName = "d")
    @ApiModelProperty("销售类型")
    private String saleTypeName;

    @ZfireField(tbName = "d")
    @ApiModelProperty("物料编码")
    private String materialNumber;

    @ZfireField(tbName = "d")
    @ApiModelProperty("厂产品代码")
    private String materialOldNumber;

    @ZfireField(tbName = "d")
    @ApiModelProperty("产品名称")
    private String materialName;

    @ZfireField(tbName = "d")
    @ApiModelProperty("规格型号")
    private String specification;

    @ZfireField(tbName = "d")
    @ApiModelProperty("数量")
    private Integer qty;

    @ZfireField(tbName = "d")
    @ApiModelProperty("单价")
    private BigDecimal price;

    @ZfireField(isQuery = false)
    @ApiModelProperty("金额")
    private BigDecimal totalAmount;

    @ZfireField(isQuery = false)
    @ApiModelProperty("未订数量")
    private Integer wdQty;

    @ZfireField(isQuery = false)
    @ApiModelProperty("未订金额")
    private BigDecimal wdAmount;

    @ZfireField(isQuery = false)
    @ApiModelProperty("直调数量")
    private Integer directTransferQty;

    @ZfireField(isQuery = false)
    @ApiModelProperty("退订数量")
    private Integer retiredQty;

    @ZfireField(isQuery = false)
    @ApiModelProperty("退货数量")
    private Integer refundProductQty;


    @ZfireField(tbName = "c")
    @ApiModelProperty("表头业务员")
    private String serviceName;

    @ZfireField(tbName = "c")
    @ApiModelProperty("审核人")
    private String confirmName;

    @ZfireField(isQuery = false)
    @ApiModelProperty("是否关闭")
    private String isClose = IsEnum.NO.getValue();

    @ZfireField(tbName = "c")
    @ApiModelProperty("备注")
    private String remark;

    @ZfireField(tbName = "c")
    @ApiModelProperty("格力内部备注")
    private String geLiInerNote;

    @ZfireField(tbName = "a")
    @ApiModelProperty("权限分类")
    private String refPowerCategory;


    @ZfireField(tbName = "c")
    @ApiModelProperty("合同有效期")
    private Date contractExpireDate;

    @ZfireField(tbName = "c")
    @ApiModelProperty("安装地址")
    private String installAddress;

    @ZfireField(tbName = "c")
    @ApiModelProperty("联系电话")
    private String phone;

    @ZfireField(tbName = "c")
    @ApiModelProperty("工程登录类型")
    private String enginSignType;
}
