package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.JiaXianProcessStatusEnum;
import com.zfire.mall.manager.plus.entity.CostMerchant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-04-08
 */
@ApiModel
@Data
public class CostMerchantListVO   {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "30")
    private String id;

    @ApiModelProperty(value = "商家对账单编码")
    private String merchantCheckCode;

    @ApiModelProperty(value = "销司对账单编码")
    private String salesCheckCode;

    @ApiModelProperty(value = "商家编码")
    private String merchantCode;

    @ApiModelProperty(value = "商家名称")
    private String merchantName;

    @ApiModelProperty(value = "对账人")
    private String checkMan;



    @ApiModelProperty(value = "对账时间")
    private Date checkTimeSupply;


    @ApiModelProperty(value = "自动核对时间")
    private Date autoCheckTimeSupply;

    @ApiModelProperty(value = "退货订单费用汇总")
    private BigDecimal totalReturnOrderCost;

    @ApiModelProperty(value = "商家应付费用")
    private BigDecimal totalMerchantCost;


    @ApiModelProperty(value = "上楼卸货费用")
    private BigDecimal totalUnloadUpstairsCost;

    @ApiModelProperty(value = "费用汇总")
    private BigDecimal totalCost;


    @ApiModelProperty(value = "对账时间范围的开始时间")
    private Date startTimeSupply;


    @ApiModelProperty(value = "对账时间范围的结束时间")
    private Date endTimeSupply;

    @ApiModelProperty(value = "备注")
    private String comment;


    @ApiModelProperty(value = "更新人")
    private String updateUser;

    @ApiModelProperty(value = "创建人")
    private String createUser;


    @ZfireField(hide = true)
    @ApiModelProperty(value = "是否已经被删除")
    private String isDelete;

    @ApiModelProperty(value = "创建时间")
    private Date costCreateTime;

    @ApiModelProperty(value = "修改时间")
    private Date costUpdateTime;

    @ApiModelProperty(value = "流程状态")
    private JiaXianProcessStatusEnum processStatus;

    @ApiModelProperty(value = "发起异常工单得单号")
    private String ticketCode;


    @ApiModelProperty(value = "销售类型名称")
    private String saleType;

    @ApiModelProperty(value = "商家费用汇总")
    private String merchantCostSum;

    @ApiModelProperty(value = "格力比例扣返利")
    private String geliRebate;

    @ApiModelProperty(value = "仓储物流费")
    private BigDecimal tocCost;

    @ApiModelProperty(value = "工程费")
    private BigDecimal tobCost;

    @ApiModelProperty(value = "TOC 补贴费用")
    private BigDecimal tocAllowanceCost;

    @ApiModelProperty(value = "TOB补贴费用")
    private BigDecimal tobAllowanceCost;

    @ApiModelProperty(value = "所属月份账单")
    private String costTerm;

    @ApiModelProperty(value = "发起商家对账时间")
    private String startMerchantCheckTime;

    @ApiModelProperty(value = "发起销司对账时间")
    private String startSalesCheckTime;

    @ApiModelProperty(value = "发起商家对账时间")
    private Date startMerchantCheckTimeSupply;

    @ApiModelProperty(value = "发起销司对账时间")
    private Date startSalesCheckTimeSupply;

    @ApiModelProperty(value = "其他费用")
    private BigDecimal otherCost;

    @ApiModelProperty(value = "其他费用附件")
    private String otherCostAttachmentUrl;

    @ApiModelProperty(value = "商家所属销售公司名称")
    private String belongSalesCompanyName;

    @ApiModelProperty(value = "商家所属销售公司名称编号")
    private String belongSalesCompanyCode;

    @ApiModelProperty(value = "商家简称")
    private String merchantShortName;

}
