package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-04-08
 */
@ApiModel
@Data
public class CostMerchantVO   {


    @ApiModelProperty(value = "30")
    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "商家对账单编码")
    private String merchantCheckCode;

    @ApiModelProperty(value = "销司对账单编码")
    private String salesCheckCode;

    @ApiModelProperty(value = "商家编码")
    private String merchantCode;

    @ApiModelProperty(value = "商家名称")
    private String merchantName;

    @ApiModelProperty(value = "对账人")
    private String checkMan;

    @ApiModelProperty(value = "对账时间")
    private Long checkTime;

    @ApiModelProperty(value = "对账时间")
    private Date checkTimeSupply;

    @ApiModelProperty(value = "自动核对时间。商家长时间不确认，系统自动确认")
    private Long autoCheckTime;

    @ApiModelProperty(value = "自动核对时间。商家长时间不确认，系统自动确认")
    private Date autoCheckTimeSupply;

    @ApiModelProperty(value = "退货订单费用汇总")
    private BigDecimal totalReturnOrderCost;

    @ApiModelProperty(value = "一般算出来的运费")
    private BigDecimal totalMerchantCost;

    @ApiModelProperty(value = "补贴费用，补贴系数*开单价")
    private BigDecimal totalAllowanceCost;

    @ApiModelProperty(value = "上楼卸货费用，上楼结算系数*开单价")
    private BigDecimal totalUnloadUpstairsCost;

    @ApiModelProperty(value = "费用汇总，前面四个费用相加")
    private BigDecimal totalCost;

    @ApiModelProperty(value = "对账时间范围的开始时间")
    private Long startTime;

    @ApiModelProperty(value = "对账时间范围的开始时间")
    private Date startTimeSupply;

    @ApiModelProperty(value = "对账时间范围的结束时间")
    private Long endTime;

    @ApiModelProperty(value = "对账时间范围的结束时间")
    private Date endTimeSupply;

    @ApiModelProperty(value = "备注")
    private String comment;

    @ApiModelProperty(value = "0")
    private String createOrg;

    @ApiModelProperty(value = "0")
    private String updateOrg;

    @ApiModelProperty(value = "更新人")
    private String updateUser;

    @ApiModelProperty(value = "创建人")
    private String createUser;

    @ApiModelProperty(value = "更新时间")
    private Long updateTime;

    @ApiModelProperty(value = "创建时间")
    private Long createTime;

    @ApiModelProperty(value = "是否已经被删除")
    private String isDelete;

}
