package com.zfire.mall.manager.bean.front;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.JiaXianCodeVerificationEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-04-10
 */
@ApiModel
@Data
public class CustomerCodeCustomerCheckVO {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "条码唯一id")
    private String id;

    @ApiModelProperty(value = "条码")
    private String barCode;

    @ApiModelProperty(value = "商家名称")
    private String salesCompany;


    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "设备仓库")
    private String stockName = "自有仓";


    @ApiModelProperty(value = "物料代码")
    private String materialCode;

    @ApiModelProperty(value = "规格")
    private String specification;


    @ApiModelProperty(value = "出库时间")
    private Date consignerTimeV2;

    @ApiModelProperty(value = "送货时间")
    private Date deliveryTimeV2;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "出库时间")
    private String consignerTime;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "送货时间")
    private String deliveryTime;

    @ApiModelProperty(value = "销售订单号")
    private String orderNumber;

    @ApiModelProperty(value = "收货人")
    private String receiptCompany;

    @ApiModelProperty(value = "收货地址")
    private String address;

    @ApiModelProperty(value = "发货仓库名称")
    private String warehouse;

    @ApiModelProperty(value = "设备状态")
    private JiaXianCodeVerificationEnum verificationStatus;

    @ApiModelProperty(value = "核验人员编号")
    private String customerNumber;

    @ApiModelProperty(value = "核验人员名称")
    private String customerName;

    @ApiModelProperty(value = "核验人员手机号")
    private String customerPhone;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    @ApiModelProperty(value = "创建人（制单人）")
    private String createBy;

    @ApiModelProperty(value = "更新人")
    private String updateBy;




}
