package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.GongDanOrderTypeEnum;
import com.zfire.mall.manager.enums.GongDanPaiGongTypeEnum;
import com.zfire.mall.manager.enums.JiaXianCodeVerificationEnum;
import com.zfire.mall.manager.plus.entity.CustomerCodeInstall;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author changelin
 */
@ApiModel
@Data
public class CustomerCodeInstallVO   {


    @ZfireField(hide = true)
    @ApiModelProperty(value = "条码唯一id")
    private String id;

    @ApiModelProperty(value = "产品名称")
    private String specification;

    @ApiModelProperty(value = "安装条码")
    private String barCode;

    @ApiModelProperty(value = "条码类型")
    private String materialType;

    @ApiModelProperty(value = "来源")
    private JiaXianCodeVerificationEnum verificationStatus;

    @ApiModelProperty(value = "派工状态")
    private GongDanPaiGongTypeEnum appointState;

    @ApiModelProperty(value = "安装信息编号")
    private String gongDanId;

    @ApiModelProperty(value = "总部信息编号")
    private String pgid;

    @ApiModelProperty(value = "销售网点编号")
    private String salesNumber;

    @ApiModelProperty(value = "销售网点名称")
    private String salesWname;

    @ApiModelProperty(value = "售后网点编号")
    private String installNumber;

    @ApiModelProperty(value = "售后网点名称")
    private String installName;

    @ApiModelProperty(value = "信息员名称")
    private String adminOfficerName;

    @ApiModelProperty(value = "信息员编号")
    private String adminOfficerNumber;


    @ApiModelProperty(value = "商家名称")
    private String salesCompany;

    @ApiModelProperty(value = "物料代码")
    private String materialCode;

    @ApiModelProperty(value = "工单状态")
    private GongDanOrderTypeEnum orderState;


    @ZfireField(hide = true)
    @ApiModelProperty(value = "出库时间")
    private String consignerTime;
    @ZfireField(hide = true)
    @ApiModelProperty(value = "送货时间")
    private String deliveryTime;

    @ApiModelProperty(value = "销售订单号")
    private String orderNumber;

    @ApiModelProperty(value = "收货人")
    private String receiptCompany;

    @ApiModelProperty(value = "收货地址")
    private String address;

    @ApiModelProperty(value = "发货仓库名称")
    private String warehouse;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    @ApiModelProperty(value = "创建人（制单人）")
    private String createBy;

    @ApiModelProperty(value = "更新人")
    private String updateBy;

    @ApiModelProperty(value = "商家编码")
    private String salesCompanyCode;


    @ZfireField(hide = true)
    @ApiModelProperty(value = "核验人员编号")
    private String customerNumber;
    @ZfireField(hide = true)
    @ApiModelProperty(value = "核验人员名称")
    private String customerName;
    @ZfireField(hide = true)
    @ApiModelProperty(value = "核验人员手机号")
    private String customerPhone;

    @ApiModelProperty(value = "出库时间")
    private Date consignerTimeV2;

    @ApiModelProperty(value = "送货时间")
    private Date deliveryTimeV2;
    @ZfireField(hide = true)
    @ApiModelProperty(value = "OUT 外机  INSIDE 内机")
    private String type;





    @ApiModelProperty(value = "服务人员名称")
    private String workerName;

    @ApiModelProperty(value = "服务人员编号")
    private String workerNumber;



    @ApiModelProperty(value = "客户电话")
    private String workerPhone;



    @ApiModelProperty(value = "创建工单编号")
    private String createNumber;

    @ApiModelProperty(value = "创建网点名称")
    private String createWname;

    @ApiModelProperty(value = "接收派工网点编号")
    private String afterNumber;

    @ApiModelProperty(value = "接收派工网点名称")
    private String afterWname;

    @ApiModelProperty(value = "接收派工时间")
    private String afterTime;


}
