package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.plus.entity.CustomerCode;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-04-10
 */
@ApiModel
@Data
public class CustomerCodeVO  {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "条码唯一id")
    private String id;

    @ApiModelProperty(value = "条码")
    private String barCode;

    @ApiModelProperty(value = "商家名称")
    private String salesCompany;

    @ApiModelProperty(value = "物料代码")
    private String materialCode;

    @ApiModelProperty(value = "规格")
    private String specification;

    @ApiModelProperty(value = "物料类型")
    private String materialType;

    @ApiModelProperty(value = "出库时间")
    private Date consignerTimeV2;

    @ApiModelProperty(value = "送货时间")
    private Date deliveryTimeV2;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "出库时间")
    private String consignerTime;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "送货时间")
    private String deliveryTime;

    @ApiModelProperty(value = "发货单号")
    private String saleEndOrderCode;

    @ApiModelProperty(value = "销售订单号")
    private String orderNumber;

    @ApiModelProperty(value = "格匠订单号")
    private String geJiangOrderCode;


    @ApiModelProperty(value = "收货人")
    private String receiptCompany;

    @ApiModelProperty(value = "收货地址")
    private String address;

    @ApiModelProperty(value = "发货仓库名称")
    private String warehouse;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;



}
