package com.zfire.mall.manager.bean.front;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.CodeStatusConstant;
import com.zfire.mall.manager.enums.JiaXianOrderTypeEnum;
import com.zfire.mall.manager.enums.JiaXianStockTypeEnum;
import com.zfire.mall.manager.enums.SyncStatusEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author changelin
 */
@ApiModel
@Data
public class CustomerRefundOrderBean {

/*    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "同步嘉贤状态")
    private SyncStatusEnum syncStatus;*/

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "嘉贤订单号")
    private String jiaxianOrderId;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "客户退货单号")
    private String id;

    @ZfireField(hide = true,tbName = "co",type = "select")
    @ApiModelProperty(value = "状态")
    private JiaXianOrderTypeEnum status;

    @ZfireField(hide = true,frontCode = CodeStatusConstant.CUSTOMER_REFUND_STATUS,tbName = "co",colName = "status",type = "select")
    @ApiModelProperty(value = "状态")
    private String statusName;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "订单时间")
    private Date orderTime;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "配送时间")
    private Date pickTime;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ZfireField(hide = true,tbName = "co")
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "用户名称")
    private String userName;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "用户电话")
    private String phone;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "省")
    private String province;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "市")
    private String city;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "区")
    private String area;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "街道")
    private String street;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "收货地址")
    private String receAddress;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "仓库")
    private JiaXianStockTypeEnum stockType;

    @ZfireField(hide = true,tbName = "co",frontCode = CodeStatusConstant.STOCK_TYPE,type = "select")
    @ApiModelProperty(value = "发货仓名称")
    private String stockTypeName;

    @ZfireField(tbName = "coi")
    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ZfireField(tbName = "coi")
    @ApiModelProperty(value = "产品编码")
    private String materialOldNumber;

    @ZfireField(tbName = "coi")
    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ZfireField(hide = true,tbName = "coi")
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ZfireField(tbName = "coi")
    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ZfireField(tbName = "coi")
    @ApiModelProperty(value = "数量")
    private Integer qty;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "备注")
    private String notes;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "制单人")
    private String createBy;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "客户销售订单")
    private String customerOrderNo;

    @ZfireField(tbName = "co")
    @ApiModelProperty(value = "退货备注")
    private String refundRemark;



}
