package com.zfire.mall.manager.bean.front;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.CodeStatusConstant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author changelin
 */
@ApiModel
@Data
public class CustomerStockAccBean {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ApiModelProperty(value = "变更时间")
    private Date changeTime;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "存货类别")
    private String categoryId;

    @ApiModelProperty(value = "存货类别名称")
    private String categoryName;

    @ApiModelProperty(value = "物料编码")
    private String materialCode;

    @ApiModelProperty(value = "产品编号")
    private String materialOldNumber;


    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "发生方向 -1=减少  1=增加 ")
    private Boolean directFlag;

    @ZfireField(colName = "direct_flag",frontCode = CodeStatusConstant.DIRECT_FLAG,type = "select")
    @ApiModelProperty(value = "发生方向")
    private String directFlagName;

    @ApiModelProperty(value = "变动数量")
    private BigDecimal stockChangeQty;

    @ApiModelProperty(value = "变动前库存")
    private BigDecimal stockCurQty;

    @ApiModelProperty(value = "结存库存")
    private BigDecimal stockCloseQty;

    @ApiModelProperty(value = "相关单号")
    private String ref;

    @ApiModelProperty(value = "相关单据类型")
    private String refType;

    @ApiModelProperty(value = "备注")
    private String notes;


}
