package com.zfire.mall.manager.bean.front;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.CodeStatusConstant;
import com.zfire.mall.manager.enums.CustomerStockEnum;
import com.zfire.mall.manager.plus.entity.CustomerStock;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author changelin
 */
@ApiModel
@Data
public class CustomerStockBean {


    @ZfireField(hide = true)
    @ApiModelProperty("id")
    private String id;

    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "产品编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "存货类别")
    private String categoryId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "存货类别编码")
    private String categoryNumber;

    @ApiModelProperty(value = "存货类别")
    private String categoryName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;


    @ApiModelProperty(value = " 前置仓结存数量")
    private BigDecimal frontStockNum;


    @ApiModelProperty(value = "前置仓锁库库存")
    private BigDecimal lockFrontStockNum;



    @ApiModelProperty(value = "前置仓库存数量")
    private BigDecimal allFrontStockNum;

    @ApiModelProperty(value = "自有仓结存数量")
    private BigDecimal customerStockNum;


    @ApiModelProperty(value = "自有仓锁库库存")
    private BigDecimal lockCustomerStockNum;

    @ApiModelProperty(value = "自有仓库存数量")
    private BigDecimal allLockCustomerStockNum;


}
