package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.plus.entity.CustomerStockOrderItem;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 物料库存三级帐
 * </p>
 *
 * @author gejiang
 * @since 2022-11-28
 */
@ApiModel
@Data
public class CustomerStockOrderItemPush {



    @ApiModelProperty(value = "发生方向 -1=减少  1=增加 ")
    private Boolean directFlag;

    @ApiModelProperty(value = "变动数量")
    private BigDecimal stockChangeQty;

    @ApiModelProperty(value = "当前库存数量")
    private BigDecimal stockCurQty;

    @ApiModelProperty(value = "结存库存数量")
    private BigDecimal stockCloseQty;


    @ApiModelProperty(value = "备注")
    private String notes;

    @ApiModelProperty(value = "旧物料编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;


    @ApiModelProperty(value = "1 前置仓 2商家仓")
    private Integer stockType;



    @ApiModelProperty(value = "存货类别编码")
    private String categoryNumber;

    @ApiModelProperty(value = "存货类别名称")
    private String categoryName;

    @ApiModelProperty(value = "物料规格型号")
    private String specification;





}
