package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.plus.entity.CustomerStockOrderItem;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 物料库存三级帐
 * </p>
 *
 * @author gejiang
 * @since 2022-11-28
 */
@ApiModel
@Data
public class CustomerStockOrderPush{



    @TableId(value = "库存调整单")
    private String id;

    @ApiModelProperty(value = "发生时间")
    private Date changeTime;

    @ApiModelProperty(value = "更新操作人名称")
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;


    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "制单人")
    private String createBy;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "单据状态 SAVE=保存 WAIT=待审核 OK=通过 FAIL=不通过 CLOSE=关闭")
    private String examineStatus;

    @ApiModelProperty(value = "审批人")
    private String approvalName;

    @ApiModelProperty(value = "审批时间")
    private Date approvalTime;

    @ApiModelProperty(value = "审批说明")
    private String approvalRemark;


    @ApiModelProperty(value = "库存调整明细")
    private List<CustomerStockOrderItemPush> customerStockOrderItems;

}
