package com.zfire.mall.manager.bean.front;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import com.zfire.mall.manager.enums.JiaXianStockEnum;
import com.zfire.mall.manager.enums.SyncStatusEnum;
import com.zfire.mall.manager.plus.entity.CustomerTransferOrderItem;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-04-07
 */
@ApiModel
@Data
public class CustomerTransferOrderBean {

    @ZfireField(type = "select",tbName = "a")
    @ApiModelProperty(value = "状态")
    private ExamineStatusEnum status;


    @ZfireField(type = "select",tbName = "a")
    @ApiModelProperty(value = "同步状态")
    private SyncStatusEnum syncStatus;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "调拨单号")
    private String id;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ZfireField(tbName = "a",hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "调拨经销商名称")
    private String transferCustomerName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "调拨经销商编号")
    private String transferCustomerNumber;

    @ZfireField(tbName = "a",hide = true)
    @ApiModelProperty(value = "调拨经销商id")
    private String transferCustomerId;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "调拨时间")
    private Date transferTime;

    @ZfireField(type = "select",tbName = "a")
    @ApiModelProperty(value = "调拨仓库")
    private JiaXianStockEnum stockType;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "备注")
    private String notes;


    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "产品编码")
    private String materialOldNumber;

    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "调拨数量")
    private Integer qty;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "创建人（制单人）")
    private String createBy;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "更新人")
    private String updateBy;







}
