package com.zfire.mall.manager.bean.invoice;

import com.zfire.mall.manager.plus.entity.InvoiceApplication;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @author change
 */
@ApiModel
@Data
public class InvoiceOrder {

    @ApiModelProperty(value = "主订单id")
    private String mainOrderId;


    @ApiModelProperty(value = "订单时间")
    private String theTime;

    @ApiModelProperty(value = "订单类型 TRADE=商用 HOME=家用 RETAIL=零售单 RETAIL_POLICY 销售政策单  PERMU_HOME = 置换单家用        PERMU_TRADE 置换商用   PERMU_RETAIL  置换零售   PERMU_RETAIL_POLICY 置换销售政策单")
    private String orderType;

    @ApiModelProperty(value = "订单商品明细id")
    private String orderId;

    @ApiModelProperty("物料id")
    private String materialId;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料代码")
    private String materialOldNumber;

    @ApiModelProperty("销售类型id")
    private String saleTypeId;

    @ApiModelProperty("销售类型名称")
    private String saleTypeName;

    @ApiModelProperty("规格型号")
    private String specification;

    @ApiModelProperty("单位")
    private String unit;

    @ApiModelProperty("数量")
    private Integer qty;

    @ApiModelProperty(value = "可退数量")
    private Integer refundableQty;
    @ApiModelProperty(value = "已退数量")
    private Integer retiredQty;

    @ApiModelProperty("已申请数量")
    private Integer alreadyInvoiceNum;

    @ApiModelProperty("未发货数量")
    private Integer sendQty;

    @ApiModelProperty("总库存数量")
    private Integer stockAdequate;

    @ApiModelProperty("对应仓库库存数量")
    private Integer stockCorrespond;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("存货品类")
    private String categoryName;

    @ApiModelProperty("可申请数量")
    private Integer canApply;

    @ApiModelProperty("表头备注")
    private String headerRemark;

    @ApiModelProperty("表体备注")
    private String invoiceRemark;

    @ApiModelProperty("1新单 0旧单")
    private Integer orderBase;

}
