package com.zfire.mall.manager.bean.invoice;

import com.zfire.mall.manager.plus.entity.InvoiceApplication;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author change
 */
@ApiModel
@Data
public class InvoicePickBean extends InvoiceApplication {

    @ApiModelProperty(value = "发货单明细id")
    private String invoiceOrderId;

    @ApiModelProperty(value = "主订单id")
    private String mainOrderId;

    @ApiModelProperty(value = "订单商品id")
    private String orderId;

    @ApiModelProperty(value = "申请发货订单号")
    private String invoiceId;

    @ApiModelProperty(value = "申请数量")
    private Integer invoiceNum;

    @ApiModelProperty(value = "审批数量")
    private Integer approvalNumber;

    @ApiModelProperty(value = "可退数量")
    private Integer refundableQty;

    @ApiModelProperty(value = "已退数量")
    private Integer retiredQty;

    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "订单类型 TRADE=商用 HOME=家用 RETAIL=零售单 RETAIL_POLICY 销售政策单  PERMU_HOME = 置换单家用        PERMU_TRADE 置换商用   PERMU_RETAIL  置换零售   PERMU_RETAIL_POLICY 置换销售政策单")
    private String orderType;

    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;

    @ApiModelProperty(value = "销售类型编号")
    private String saleTypeCode;

    @ApiModelProperty(value = "销售类型名称")
    private String saleTypeName;

    @ApiModelProperty(value = "单据日期")
    private Date theTime;

    @ApiModelProperty(value = "旧物料编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty(value = "物料规格型号")
    private String specification;

    @ApiModelProperty(value = "单位")
    private String unit;

    @ApiModelProperty(value = "单价")
    private BigDecimal price;

    @ApiModelProperty(value = "实付金额(订单金额-返利金额-折扣金额-不够扣的返利金额)")
    private BigDecimal payAmount;

    @ApiModelProperty(value = "税率例如: 0.13")
    private BigDecimal tax;

    @ApiModelProperty(value = "数量")
    private Integer qty;

    @ApiModelProperty(value = "税后单价")
    private BigDecimal afterTaxPrice;

    @ApiModelProperty(value = "无税金额")
    private BigDecimal noTotalAmount;

    @ApiModelProperty(value = "实际扣除的返利金额")
    private BigDecimal payRebateAmount;

    @ApiModelProperty(value = "总的格力折扣金额")
    private BigDecimal totalDiscAmount;

    @ApiModelProperty(value = "提货ID")
    private String pickId;

    @ApiModelProperty(value = "打印次数")
    private Integer printNum;

    @ApiModelProperty(value = "0 为打单 1已打单 2已出货 3弃单")
    private Integer status;

    @ApiModelProperty(value = "打单日期")
    private Date printTime;

    @ApiModelProperty(value = "实际提货时间")
    private Date pickActualTime;

    @ApiModelProperty(value = "配件型号1")
    private String pjxh1Text;

    @ApiModelProperty(value = "收货客户")
    private String receivingName;

    @ApiModelProperty(value = "电话")
    private String phone;

    @ApiModelProperty(value = "收货地址")
    private String address;

    @ApiModelProperty(value = "0 前置仓 1工程机 2商家仓")
    private Integer warehouseFlag;

    @ApiModelProperty(value = "收货地址")
    private String customerOrderId;


}
