package com.zfire.mall.manager.bean.invoice;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author change
 */
@ApiModel
@Data
public class InvoiceProjectOrder {

    @ApiModelProperty(value = "主订单id")
    private String mainOrderId;

    @ApiModelProperty(value = "工程订单编号")
    private String enginOrderNo;

    @ApiModelProperty(value = "订单时间")
    private String orderDate;

    @ApiModelProperty(value = "订单类型 TRADE=商用 HOME=家用 RETAIL=零售单 RETAIL_POLICY 销售政策单  PERMU_HOME = 置换单家用        PERMU_TRADE 置换商用   PERMU_RETAIL  置换零售   PERMU_RETAIL_POLICY 置换销售政策单")
    private String orderType;

    @ApiModelProperty(value = "订单商品明细id")
    private String orderId;

    @ApiModelProperty("物料id")
    private String materialId;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料代码")
    private String materialOldNumber;

    @ApiModelProperty("销售类型id")
    private String saleTypeId;

    @ApiModelProperty("销售类型名称")
    private String saleTypeName;

    @ApiModelProperty("规格型号")
    private String specification;

    @ApiModelProperty("单位")
    private String unit;

    @ApiModelProperty("订单数量")
    private Integer qty;

    @ApiModelProperty(value = "可退数量/未申请数量")
    private Integer refundableQty;
    @ApiModelProperty(value = "已退数量")
    private Integer retiredQty;

    @ApiModelProperty("已申请数量")
    private Integer alreadyInvoiceNum;

    @ApiModelProperty("开单未提")
    private Integer sendQty;

    @ApiModelProperty("总库存数量")
    private Integer stockAdequate;

    @ApiModelProperty("对应仓库库存数量")
    private Integer stockCorrespond;

    @ApiModelProperty("存货类别")
    private String categoryName;

    @ApiModelProperty(value = "工程登录编号")
    private String refEnginRecordNo;

    @ApiModelProperty(value = "销售订单表头")
    private String headerRemark;

    @ApiModelProperty(value = "销售订单表体")
    private String invoiceRemark;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "项目类别")
    private String refProjectCategory;

    @ApiModelProperty(value = "行业类别")
    private String refTradeCategory;


    @ApiModelProperty(value = "工程登录类型")
    private String refPromiseStatus;

    @ApiModelProperty("1新单 0旧单")
    private Integer orderBase;
}
