package com.zfire.mall.manager.bean.invoice;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.zfire.mall.manager.plus.entity.InvoiceApplication;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @author change
 */
@ApiModel
@Data
public class InvoiceRetreatOrder {

    @ApiModelProperty(value = "订单号")
    private String id;

    @ApiModelProperty(value = "数量")
    private Integer refundableQty;


    @ApiModelProperty(value = "1 申请发货单  2退货单")
    private Integer inOrderType;

    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;



    @ApiModelProperty(value = "单据日期")
    private Date orderTime;

    @ApiModelProperty(value = "旧物料编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty(value = "物料规格型号")
    private String specification;


    @ApiModelProperty(value = "实付金额(订单金额-返利金额-折扣金额-不够扣的返利金额)")
    private BigDecimal payAmount;


    @ApiModelProperty(value = "税后单价")
    private BigDecimal afterTaxPrice;

    @ApiModelProperty(value = "无税金额")
    private BigDecimal noTotalAmount;


    @ApiModelProperty(value = "订单金额")
    private BigDecimal totalAmount;

    @ApiModelProperty(value = "仓库ID")
    private String correspondId;

    @ApiModelProperty(value = "仓库名称")
    private String correspondName;


    @ApiModelProperty(value = "经销商名称")
    private String customerName;


}
