package com.zfire.mall.manager.bean.k3;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

@Data
public class RequestBillBean {
    /**
     * 需要更新的字段
     */
    @JsonProperty("NeedUpDateFields")
    private String[] needUpDateFields = new String[0];

    /**
     * 需返回结果的字段集合
     */
    @JsonProperty("NeedReturnFields")
    private String[] needReturnFields = new String[0];

    /**
     * 是否删除已存在的分录
     */
    @JsonProperty("IsDeleteEntry")
    private boolean isDeleteEntry = true;
    /**
     * 表单所在的子系统内码
     */
    @JsonProperty("SubSystemId")
    private String subSystemId = "";

    /**
     * 是否验证所有的基础资料有效性，布尔类，默认false
     */
    @JsonProperty("IsVerifyBaseDataField")
    private boolean isVerifyBaseDataField = false;

    /**
     * 是否批量填充分录，默认true
     */
    @JsonProperty("IsEntryBatchFill")
    private boolean isEntryBatchFill = true;

    /**
     * 是否验证标志，布尔类型，默认true
     */
    @JsonProperty("ValidateFlag")
    private boolean validateFlag = true;

    /**
     * 是否用编码搜索基础资料，布尔类型，默认true
     */
    @JsonProperty("NumberSearch")
    private boolean numberSearch = true;

    /**
     * 是否验证标志，布尔类型，默认true
     */
    @JsonProperty("IsAutoAdjustField")
    private boolean isAutoAdjustField = false;

    /**
     * 自动提交和审核，默认true true为自动提交审核，false只是创建状态
     */
    @JsonProperty("IsAutoSubmitAndAudit")
    private boolean isAutoSubmitAndAudit = true;

    /**
     * 交互标志集合，字符串类型
     */
    @JsonProperty("InterationFlags")
    private String interationFlags;

    /**
     * 是否允许忽略交互，布尔类型，默认true
     */
    @JsonProperty("IgnoreInterationFlag")
    private boolean ignoreInterationFlag;

    /**
     *
     */
    @JsonProperty("Model")
    private Object model;
}
