package com.zfire.mall.manager.bean.k3.bill;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.zfire.mall.manager.constant.KingDeeCons;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@ApiModel
@Data
@JsonIgnoreProperties(value = { "orgNumber","customerNumber","salerNumber"})
public class TransferOrderBean extends CommonOrderBean {

    /**
     * id
     */
    @JsonProperty("FID")
    @ApiModelProperty(value = "下游单据内码id")
    private String id;

    /**
     * 日期
     */
    @JsonProperty("FDate")
    @ApiModelProperty(value = "日期")
    private String date;

    /**
     * 备注
     */
    @JsonProperty("FNote")
    private String remarks;


    /**
     * 是否提前开票 001 是
     */
    @JsonProperty("F_kls_Combo")
    private String klsCombo;

    /**
     * 退料明细
     */
    @JsonProperty("FBillEntry")
    @ApiModelProperty(value = "明细")
    private List<TransferOrderBeanStock> entry;

    @ApiModelProperty(value = "是否下推更新")
    private boolean isPushUpdate = true;

    @Override
    public boolean isPushUpdate() {
        return isPushUpdate;
    }

    @Override
    public String[] pushUpdateFields() {
        return new String[]{"FDate","FBillNo", "FNote", "FBillEntry", "FSrcStockId","FDestStockId","F_kls_Combo","FMaterialId","FQty"};
    }

}
