package com.zfire.mall.manager.bean.listV2;

import com.baomidou.mybatisplus.annotation.*;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.annotation.ZfireList;
import com.zfire.mall.manager.enums.IsEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 对账列表
 */
@ZfireField(tbName = "a")
@ApiModel
@Data
public class CustomerWalletRecordVO {

    @ZfireField(hide = true)
    private String id;
    @ZfireField(isQuery = false)
    @ApiModelProperty("月份")
    private String month;
    @ApiModelProperty("是否对账")
    private IsEnum isReconciliation;
    @ApiModelProperty("客户编码")
    private String customerCode;
    @ApiModelProperty("客户名称")
    private String customerName;
    @ApiModelProperty("现金钱包")
    private String walletName;
    @ApiModelProperty("单据类型")
    private String billType;
    @ApiModelProperty("单据号")
    private String billNo;
    @ApiModelProperty("单据日期")
    private Date theTime;
    @ApiModelProperty("备注")
    private String remark;
    @ApiModelProperty("收付款金额")
    private BigDecimal amount;

}
