package com.zfire.mall.manager.bean.listV2;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.SysDictConstant;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@ApiModel
@Data
public class CustomerWalletTransferVO {

    @ApiModelProperty("返利转账单号")
    private String id;
    @ApiModelProperty(value = "审核状态")
    private ExamineStatusEnum examineStatus;
    @ApiModelProperty(value = "申请时间")
    private Date applyTime;
    @ApiModelProperty(value = "发起方经销商编号")
    private String customerNumber;
    //@ZfireField(type = "select",colName = "customer_number",frontCode = SysDictConstant.CUSTOMER)
    @ApiModelProperty(value = "发起方经销商名称")
    private String customerName;

    @ZfireField(type = "select",colName = "initiator_customer_wallet_id",frontCode = SysDictConstant.WALLET_REBATE)
    @ApiModelProperty(value = "发起方钱包")
    private String initiatorCustomerWalletName;
    @ApiModelProperty(value = "发起方备注")
    private String initiatorRemark;
    @ZfireField(type = "select",colName = "receiver_customer_wallet_id",frontCode = SysDictConstant.WALLET_REBATE)
    @ApiModelProperty(value = "接收方钱包")
    private String receiverCustomerWalletName;
    @ApiModelProperty(value = "接收方备注")
    private String receiverRemark;
    @ApiModelProperty(value = "返利金额")
    private BigDecimal amount;
    @ApiModelProperty(value = "折让金额")
    private BigDecimal allowanceAmount;
    @ApiModelProperty("备注")
    private String remark;
    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;
    @ApiModelProperty(value = "接收方经销商名称")
    private String receiverCustomerName;
    @ApiModelProperty(value = "单据日期")
    private Date theTime;

    @ApiModelProperty(value = "审核人")
    private String examineBy;
    @ApiModelProperty(value = "审核时间")
    private Date examineTime;
    @ApiModelProperty(value = "审核备注")
    private String examineRemark;
    @ApiModelProperty(value = "复审人")
    private String secondExamineBy;
    @ApiModelProperty(value = "复审时间")
    private Date secondExamineTime;
    @ApiModelProperty(value = "第二次审核备注")
    private String secondExamineRemark;

    @ApiModelProperty("创建时间")
    private Date createTime;
    @ApiModelProperty("创建人")
    private String createBy;
    @ApiModelProperty("修改时间")
    private Date updateTime;
    @ApiModelProperty("修改人")
    private String updateBy;


    @ApiModelProperty(value = "取消人")
    private String cancelBy;
    @ApiModelProperty(value = "取消时间")
    private Date cancelTime;

}
