package com.zfire.mall.manager.bean.listV2;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.CuseromtTypeEnum;
import com.zfire.mall.manager.enums.K3CommonStatusEnum;
import com.zfire.mall.manager.enums.K3CustomerStatusEnum;
import com.zfire.mall.manager.plus.entity.KingDeeCustomer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@ZfireField(tbName = "a")
@ApiModel
@Data
public class K3CustomerVO   {

    @ZfireField(hide = true,pk = true)
    private String id;

    @ApiModelProperty(value = "客户编码")
    private String number;

    @ApiModelProperty(value = "客户名称")
    private String name;

    @ApiModelProperty(value = "使用组织")
    private String useOrgId;

    @ApiModelProperty(value = "使用组织编码")
    private String useOrgNumber;

    @ApiModelProperty(value = "使用组织名称")
    private String useOrgName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "KING 金蝶经销商  JIAXIAN嘉贤二级经销商  GONGCHENG 商用经销商")
    private CuseromtTypeEnum jiaxianType;

    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "供应链账号状态")
    private K3CustomerStatusEnum status;

    @ApiModelProperty(value = "禁用状态")
    private K3CommonStatusEnum forbidStatus;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "修改人")
    private String updateBy;

    @ApiModelProperty(value = "修改时间")
    private Date updateTime;




}
