package com.zfire.mall.manager.bean.listV2;

import com.zfire.mall.manager.annotation.ZfireField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@ApiModel
@Data
public class K3MaterialVO {

    @ZfireField(hide = true,pk = true)
    private String id;

    @ApiModelProperty(value = "物料编码")
    private String number;

    @ApiModelProperty(value = "物料名称")
    private String name;

    @ApiModelProperty(value = "旧物料编码")
    private String oldNumber;

    @ApiModelProperty(value = "使用组织编码")
    private String useOrgNumber;

    @ApiModelProperty(value = "使用组织名称")
    private String useOrgName;

    @ApiModelProperty(value = "存货类别编码")
    private String categoryNumber;

    @ApiModelProperty(value = "存货类别名称")
    private String categoryName;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ApiModelProperty(value = "基本单位名称")
    private String baseUnitId;

    @ApiModelProperty(value = "库存单位名称")
    private String storeUnitId;

    @ApiModelProperty(value = "销售单位名称")
    private String salePriceUnitId;

    @ApiModelProperty(value = "采购单位名称")
    private String purchasePriceUnitId;

    @ApiModelProperty(value = "采购单位编号")
    private String purchasePriceUnitCode;

    @ApiModelProperty(value = "税率 例如：0.13")
    private BigDecimal taxRateId;

    @ApiModelProperty(value = "物料分组编码")
    private String materialGroupNumber;

    @ApiModelProperty(value = "物料分组名称")
    private String materialGroupName;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

}
