package com.zfire.mall.manager.bean.listV2;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.SysDictConstant;
import com.zfire.mall.manager.enums.K3ReceiptBillTypeEnum;
import com.zfire.mall.manager.enums.K3StatusEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@ApiModel
@Data
public class K3ReceiptVO {

    @ZfireField(hide = true)
    private String id;
    @ApiModelProperty(value = "单据类型")
    private K3ReceiptBillTypeEnum billType;
    @ApiModelProperty(value = "单据编码")
    private String billNo;
    @ApiModelProperty(value = "业务日期")
    private Date theTime;
    @ApiModelProperty(value = "单据状态")
    private K3StatusEnum status;
    @ZfireField(tbName = "b",colName = "name")
    @ApiModelProperty(value = "钱包")
    private String walletName;
    //@ZfireField(colName = "customer_id",type="select",frontCode = SysDictConstant.CUSTOMER)
    @ZfireField(tbName = "c",colName = "name")
    @ApiModelProperty("往来单位")
    private String customerName;
    @JsonProperty("hAmount")
    @ApiModelProperty(value = "应收金额")
    private BigDecimal hAmount;
    @ApiModelProperty(value = "实收金额")
    private BigDecimal amount;
    //@ZfireField(colName = "wl_company_type",type="select",frontCode = SysDictConstant.CUSTOMER)
    @ZfireField(tbName = "d",colName = "name")
    @ApiModelProperty("付款单位")
    private String wlCompanyName;
    @ApiModelProperty(value = "备注")
    private String remark;
    @ApiModelProperty("业务员名称")
    private String serviceName;


}
