package com.zfire.mall.manager.bean.listV2;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.plus.entity.OrderPlanCustomer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 经销商采购计划单
 * </p>
 *
 * @author gejiang
 * @since 2023-03-20
 */

@ZfireField(tbName = "a")
@ApiModel
@Data
public class OrderPlanCustomerVO  {

    @ZfireField(hide = true,pk = true)
    @ApiModelProperty(value = "id")
    private String id;

    @ZfireField(type = "select")
    @ApiModelProperty(value = "订单类型")
    private OrderPlanCustomer orderType;

    @ApiModelProperty(value = "销售类型名称")
    private String saleName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ApiModelProperty(value = "单位")
    private String unit;

    @ApiModelProperty(value = "单价")
    private BigDecimal price;

    @ApiModelProperty(value = "金额")
    private BigDecimal amount;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商名字")
    private String customerName;

    @ApiModelProperty(value = "经销商编码")
    private String customerNumber;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "修改人")
    private String updateBy;

    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    @ApiModelProperty(value = " 单据编号")
    private String billNo;

    @ApiModelProperty(value = "产品品类")
    private String materialType;


}
