package com.zfire.mall.manager.bean.listV2;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import com.zfire.mall.manager.enums.IsEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@ApiModel
@Data
public class RebateOrderVO {

    @ApiModelProperty("返利单号")
    private String rebateOrderId;
    @ApiModelProperty("状态")
    private ExamineStatusEnum examineStatus;
    @ApiModelProperty("返利日期")
    private Date theTime;
    @ApiModelProperty("经销商编码")
    private String customerNumber;
    @ApiModelProperty("经销商名称")
    private String customerName;
    @ApiModelProperty("返利类型")
    private String walletName;
    @ApiModelProperty("总返利金额")
    private BigDecimal amount;
    @ApiModelProperty("返利金额")
    private BigDecimal rebateAmount;
    @ApiModelProperty("暂扣返利")
    private BigDecimal withholdAmount;
    @ApiModelProperty("折让编号")
    private String allowanceCode;
    @ApiModelProperty("折让帐号")
    private String allowanceAccount;
    @ApiModelProperty("已办理折让金额")
    private BigDecimal handledAllowanceAmount;
    @ApiModelProperty("折让对应收款单号")
    private String allowanceOrderNo;
    @ApiModelProperty("政策文件流水号")
    private String policyFileNo;
    @ApiModelProperty("政策文号")
    private String policyDocNo;
    @ApiModelProperty("政策年份")
    private String policyYear;
    @ApiModelProperty("政策月份")
    private String policyMonth;
    @ApiModelProperty("政策归属部门")
    private String policyOrg;
    @ApiModelProperty("客户区域")
    private String customerArea;
    @ApiModelProperty("客户属性")
    private String customerAttr;
    @ApiModelProperty("奖励实际归属客户")
    private String rewardActualCustomers;
    @ApiModelProperty("备注1")
    private String remark1;
    @ApiModelProperty("备注2")
    private String remark2;
    @ApiModelProperty("制单人")
    private String createBy;
    @ApiModelProperty("制单时间")
    private Date createTime;
    @ApiModelProperty("审核人")
    private String examineBy;
    @ApiModelProperty("审核时间")
    private Date examineTime;
    @ApiModelProperty("确认时间")
    private Date customerConfirmTime;
    @ApiModelProperty("复核人")
    private String secondExamineBy;
    @ApiModelProperty("复核时间")
    private Date secondExamineTime;
    @ApiModelProperty(value = "客户是否已确认")
    private IsEnum customerIsConfirm;
}
