package com.zfire.mall.manager.bean.listV2;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import com.zfire.mall.manager.plus.entity.ReceivableOrder;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@ApiModel
@Data
public class ReceivableItemVO  {

    @ZfireField(tbName = "b",colName = "id")
    @ApiModelProperty(value = "表体行号")
    private String itemId;

    @ApiModelProperty("单据来源")
    private String source;
    @ApiModelProperty("单据编码")
    private String id;
    @ApiModelProperty("业务日期")
    private Date theTime;
//    @ApiModelProperty("往来客户单位类型")
//    private String userType;
    @ZfireField(tbName = "c",colName = "name")
    @ApiModelProperty("往来单位")
    private String customerName;
    @ApiModelProperty("币别")
    private String amountType;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty("单据状态")
    private ExamineStatusEnum examineStatus;
    @ApiModelProperty("总金额")
    private BigDecimal totalAmount;
    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "费用项目编号")
    private String projectCode;
    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "费用项目")
    private String projectName;
    @ZfireField(tbName = "b")
    @ApiModelProperty(value = "经销商钱包")
    private String customerWalletName;
//    @ApiModelProperty(value = "发票类型")
//    private String invoiceType;
    @ApiModelProperty(value = "税额")
    private BigDecimal tax;
    @ApiModelProperty(value = "税率")
    private BigDecimal taxRate;

    @ApiModelProperty("审核人")
    private String examineBy;
    @ApiModelProperty("审核备注")
    private String examineRemark;
    @ApiModelProperty("审核时间")
    private Date examineTime;


}
