package com.zfire.mall.manager.bean.manage.material;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.zfire.mall.manager.bean.valid.EditGroup;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value="MachineConfigureRecordBean对象", description="MachineConfigureRecordBean对象")
public class MachineConfigureRecordBean {

    private static final long serialVersionUID=1L;

    @NotEmpty(message = "编码不能空", groups = EditGroup.class)
    @ApiModelProperty(value = "编码", notes = "添加时非填充，编辑时必填")
    private String id;

    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @ApiModelProperty(value = "类型 INNER=内机 OUTSIDE=外机 PARTS=配件, 字典=MACHINE_CONFIGURE")
    private String type;

    @ApiModelProperty(value = "名称", required = true, notes = "必填")
    private String name;

    @ApiModelProperty(value = "编码", required = true, notes = "必填")
    private String number;

    @ApiModelProperty(value = "型号", required = true, notes = "必填")
    private String model;

    @ApiModelProperty(value = "体积", required = true, notes = "必填")
    private BigDecimal volume;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建人名称")
    private String createName;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新人名称")
    private String updateName;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

}
