package com.zfire.mall.manager.bean.manage.product.category;

import com.zfire.mall.manager.bean.valid.EditGroup;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.Date;
import java.util.List;

@Data
@ApiModel
public class ProductCategoryBean {

    private static final long serialVersionUID=1L;

    @NotEmpty(message = "产品品类id不能为空", groups = EditGroup.class)
    @ApiModelProperty(value = "产品品类id")
    private String productCategoryId;

    @NotEmpty(message = "产品品类编码不能为空")
    @ApiModelProperty(value = "产品品类编码")
    private String productCategoryNumber;

    @NotEmpty(message = "产品品类名称不能为空")
    @ApiModelProperty(value = "产品品类名称")
    private String productCategoryName;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建人名称")
    private String createName;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    private String updateBy;

    @ApiModelProperty(value = "更新人名称")
    private String updateName;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "产品品类小类列表", notes = "添加品类时不用传，添加品类小类时传")
    private List<ProductCategoryRelaBean> items;
}
