package com.zfire.mall.manager.bean.manage.product.price;

import com.zfire.mall.manager.plus.entity.ProductPriceWallet;
import com.zfire.mall.manager.plus.entity.ProductUpdPriceBill;
import com.zfire.mall.manager.plus.entity.ProductUpdPriceBillItemWallet;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;

@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value="ProductUpdPriceBillListBean对象", description="ProductUpdPriceBillListBean对象")
public class ProductUpdPriceBillListBean extends ProductUpdPriceBill {

    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;

    @ApiModelProperty(value = "销售类型编码")
    private String saleTypeCode;

    @ApiModelProperty(value = "销售类型名称")
    private String saleTypeName;

    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "金蝶物料编码")
    private String materialNumber;

    @ApiModelProperty(value = "金蝶物料名称")
    private String materialName;

    @ApiModelProperty(value = "金蝶物料旧编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "规格")
    private String specification;

    @ApiModelProperty(value = "基本单位编码")
    private String unit;

    @ApiModelProperty(value = "批发价")
    private BigDecimal batchPrice;

    @ApiModelProperty(value = "零售价")
    private BigDecimal retailPrice;

    @ApiModelProperty(value = "返利使用比例")
    private BigDecimal rebateUseRate;

    @ApiModelProperty(value = "生效日期")
    private LocalDate startDate;

    @ApiModelProperty(value = "失效日期")
    private LocalDate endDate;

    @ApiModelProperty(value = "是否促销价 0=否 1=是")
    private Boolean isPromote;

    @ApiModelProperty(value = "数量")
    private BigDecimal qty;

    @ApiModelProperty(value = "是否发布 0=否 1=是")
    private Boolean isPublish;

    @ApiModelProperty("大类名称")
    private String mainName;
    @ApiModelProperty("格力折扣金额")
    private BigDecimal discAmount;

    @ApiModelProperty("钱包")
    private List<ProductWalletBean> wallets;

    @ApiModelProperty("明细id")
    private String itemId;

}
