package com.zfire.mall.manager.bean.manage.take;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.time.LocalDate;
import java.util.Date;

@Data
@ApiModel(value="TakerRecordBean对象", description="TakerRecordBean对象")
public class TakerRecordBean {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "编码", notes = "非填充")
    private String id;

    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @NotEmpty(message = "请选择经销商")
    @ApiModelProperty(value = "客户编码", notes = "增加时必填")
    private String customerId;

    @ApiModelProperty(value = "客户名称", notes = "非填充")
    private String customerName;

    @NotEmpty(message = "提货人姓名不能为空")
    @ApiModelProperty(value = "提货人姓名", notes = "增加时必填")
    private String takerName;

    @NotEmpty(message = "身份证号码不能为空")
    @ApiModelProperty(value = "身份证号码", notes = "增加时必填")
    private String identity;

    @NotEmpty(message = "联系电话不能为空")
    @Pattern(regexp = "1[2-9]\\d{9}", message = "联系电话不符合格式")
    @ApiModelProperty(value = "联系电话", notes = "增加时必填")
    private String phone;

    @ApiModelProperty(value = "备用电话", notes = "增加时必填")
    private String sparePhone;

    @NotNull(message = "有效期不能为空")
    @ApiModelProperty(value = "有效期", notes = "增加时必填")
    private LocalDate expireTime;

    @ApiModelProperty(value = "文件名")
    private String fileName;

    @ApiModelProperty(value = "文件地址")
    private String fileUrl;

/*    @NotEmpty(message = "验证码不能为空")*/
    @ApiModelProperty(value = "验证码", notes = "增加时必填")
    private String code;

    @ApiModelProperty(value = "状态", notes = "非填充")
    private Integer flag;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建人名称")
    private String createName;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "更新人名称")
    private String updateBy;

    @ApiModelProperty(value = "更新人名称")
    private String updateName;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

}
