package com.zfire.mall.manager.bean.manage.v2.material;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.MachineConfigureTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
public class ProductComposeVO {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "编码")
    private String id;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ZfireField(tbName = "m", colName = "name")
    @ApiModelProperty(value = "金蝶物料名称")
    private String materialName;

    @ZfireField(tbName = "m", colName = "specification")
    @ApiModelProperty(value = "产品型号")
    private String productModel;

//    @ApiModelProperty(value = "套机编码")
//    private String composeNumber;
//
//    @ApiModelProperty(value = "套机体积")
//    private BigDecimal productVolume;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "创建人名称")
    private String createName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "更新人名称")
    private String updateName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ZfireField(tbName = "c")
    @ApiModelProperty(value = "类型")
    private MachineConfigureTypeEnum type;

    @ZfireField(tbName = "c")
    @ApiModelProperty(value = "名称")
    private String name;

    @ZfireField(tbName = "c")
    @ApiModelProperty(value = "编码")
    private String number;

    @ZfireField(tbName = "c")
    @ApiModelProperty(value = "型号")
    private String model;

    @ZfireField(tbName = "c")
    @ApiModelProperty(value = "体积")
    private BigDecimal volume;
}
