package com.zfire.mall.manager.bean.manage.v2.product.price;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.IsEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
public class ProductBusinessPriceVO {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "厂产品编码")
    private String productCode;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;

    @ApiModelProperty(value = "销售类型编码")
    private String saleTypeCode;

    @ApiModelProperty(value = "销售类型名称")
    private String saleTypeName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ApiModelProperty(value = "厂产品代码")
    private String materialOldNumber;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ApiModelProperty(value = "基本单位编码")
    private String unit;

    @ApiModelProperty(value = "批发价")
    private BigDecimal batchPrice;

    @ApiModelProperty(value = "零售价")
    private BigDecimal retailPrice;

    @ApiModelProperty(value = "格力折扣金额")
    private BigDecimal discAmount;

    @ApiModelProperty(value = "是否促销价")
    private IsEnum isPromote;

    @ApiModelProperty(value = "数量下限")
    private Integer qty;

    @ApiModelProperty(value = "是否启用")
    private IsEnum isRevoke;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "业务员id")
    private String serviceId;

    @ApiModelProperty(value = "业务员名称")
    private String serviceName;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

}
