package com.zfire.mall.manager.bean.manage.v2.product.price;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.IsEnum;
import com.zfire.mall.manager.enums.OrderTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
public class ProductPriceVO {

    @ZfireField(tbName = "a", hide = true)
    @ApiModelProperty(value = "id")
    private String id;

    @ZfireField(tbName = "a", hide = true)
    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @ZfireField(tbName = "a", hide = true)
    @ApiModelProperty(value = "来源id")
    private String refId;

    @ApiModelProperty(value = "单据类型")
    private OrderTypeEnum billType;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "品类code")
    private String mainId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "品类名称")
    private String mainName;

    @ZfireField(tbName = "a", hide = true)
    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;

    @ApiModelProperty(value = "销售类型编码")
    private String saleTypeCode;

    @ApiModelProperty(value = "销售类型名称")
    private String saleTypeName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ApiModelProperty(value = "厂产品编码")
    private String materialOldNumber;

//    @ApiModelProperty(value = "金蝶物料类型id")
//    private String k3CategoryId;
//
//    @ApiModelProperty(value = "金蝶物料类型编号")
//    private String k3CategoryNumber;
//
//    @ApiModelProperty(value = "金蝶物料类型名称")
//    private String k3CategoryName;

    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ApiModelProperty(value = "基本单位编码")
    private String unit;

    @ApiModelProperty(value = "批发价")
    private BigDecimal batchPrice;

//    @ApiModelProperty(value = "零售价")
//    private BigDecimal retailPrice;

    @ApiModelProperty(value = "格力折扣金额")
    private BigDecimal discAmount;

    @ApiModelProperty(value = "生效日期")
    private Date startDate;

    @ApiModelProperty(value = "失效日期")
    private Date endDate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "返利类型（钱包）")
    private String rebateWallet;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "现金钱包")
    private String commonlyWallet;

//    @ApiModelProperty(value = "是否促销价")
//    private IsEnum isPromote;

//    @ApiModelProperty(value = "数量下限")
//    private Integer qty;

    @ApiModelProperty(value = "是否作废")
    private IsEnum isRevoke;

    @ApiModelProperty(value = "备注")
    private String remark;

//    @ApiModelProperty(value = "业务员编号")
//    private String serviceId;

    @ApiModelProperty(value = "业务员名称")
    private String serviceName;

//    @ApiModelProperty(value = "部门编号")
//    private String adminWebsitId;

    @ApiModelProperty(value = "部门名称")
    private String adminWebsitName;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;


}
