package com.zfire.mall.manager.bean.manage.v2.take;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.TakeFlagEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDate;
import java.util.Date;

@Data
@ApiModel
public class TakerRecordVO {

    @ZfireField(tbName = "a", hide = true)
    @ApiModelProperty(value = "编码")
    private String id;

    @ZfireField(tbName = "a", hide = true)
    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

//    @ApiModelProperty(value = "客户编码")
//    private String customerId;
    @ZfireField(tbName = "b", colName = "name")
    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "提货人姓名")
    private String takerName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "身份证号码")
    private String identity;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "联系电话")
    private String phone;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "状态")
    private TakeFlagEnum flag;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "备用电话")
    private String sparePhone;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "有效期")
    private LocalDate expireTime;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "创建人")
    private String createName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "更新人")
    private String updateName;

    @ZfireField(tbName = "a")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
}
