package com.zfire.mall.manager.bean.record.order.exec.v2;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.SysDictConstant;
import com.zfire.mall.manager.enums.OrderTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@Data
@ApiModel
public class OrderExecRecordVO {
    @ApiModelProperty("订单号")
    private String refOrderId;

    @ApiModelProperty("工程登录编号")
    private String refEnginRecordNo;

    @ZfireField(type = "select")
    @ApiModelProperty("订单类型")
    private OrderTypeEnum orderType;

    @ApiModelProperty("订单日期")
    private Date theTime;

    @ZfireField(tbName = "b",type = "select",colName = "sale_type_id",frontCode = SysDictConstant.SALE_TYPE)
    @ApiModelProperty("销售类型")
    private String saleTypeName;

    @ApiModelProperty("经销商")
    private String customerName;

    @ApiModelProperty("物料编码")
    private String materialCode;

    @ApiModelProperty("产品名称")
    private String materialName;

    @ApiModelProperty("厂产品编码")
    private String materialOldNumber;

    @ApiModelProperty("规格型号")
    private String specification;
    @ZfireField(tbName = "a",type = "select",multiple = true,colName = "k3_category_id",frontCode = SysDictConstant.K3_CATEGORY)
    @ApiModelProperty("产品类别")
    private String k3CategoryName;

    @ApiModelProperty("单位")
    private String unit;

    @ZfireField(tbName = "a",type = "select",frontCode = SysDictConstant.WALLET_REBATE)
    @ApiModelProperty("返利钱包名称")
    private String customerWalletName2;

    @ZfireField(tbName = "a",type = "select",frontCode = SysDictConstant.WALLET)
    @ApiModelProperty("现金钱包名称")
    private String customerWalletName;

    @ApiModelProperty("来源类型")
    private String refType;

    @ApiModelProperty("单价")
    private BigDecimal price;

//    @ZfireField(isQuery = false)
//    @ApiModelProperty("方向")
//    private Integer direction;

    @ZfireField(isQuery = false)
    @ApiModelProperty("数量")
    private Integer itemQty;

    @ZfireField(isQuery = false)
    @ApiModelProperty("实付金额")
    private BigDecimal itemPayAmount;

    @ZfireField(isQuery = false)
    @ApiModelProperty("实际返利金额")
    private BigDecimal itemPayRebateAmount;

    @ZfireField(isQuery = false)
    @ApiModelProperty("格力折扣单价")
    private BigDecimal itemDiscAmount;

    @ZfireField(isQuery = false)
    @ApiModelProperty("格力折扣总额")
    private BigDecimal itemTotalDiscAmount;

    @ZfireField(isQuery = false)
    @ApiModelProperty("原供价")
    private BigDecimal orgPrice;

    @ZfireField(isQuery = false)
    @ApiModelProperty("原订单数量")
    private Integer oldQty;

    @ZfireField(isQuery = false)
    @ApiModelProperty("原订单实际支付金额")
    private BigDecimal oldPayAmount;

    @ApiModelProperty("表头业务员")
    private String k3ServiceName;

    @ApiModelProperty("表体业务员")
    private String serviceName;

    @ApiModelProperty("物料分类")
    private String materialGroupName;

    @ApiModelProperty("操作人")
    private String createBy;

    @ApiModelProperty("操作日期")
    private Date createTime;

    @ApiModelProperty("订单制单日期")
    private Date orderCreateTime;

}
