package com.zfire.mall.manager.bean.record.order.exec.v2;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.SysDictConstant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ZfireField(tbName = "a")
@Data
@ApiModel
public class RetailOrderExecRecordVO {
    @ApiModelProperty("订单号")
    private String id;
    @ApiModelProperty("订单日期")
    private Date theTime;
    @ZfireField(tbName = "b",type = "select",colName = "sale_type_id",frontCode = SysDictConstant.SALE_TYPE)
    @ApiModelProperty("销售类型")
    private String saleTypeName;

    @ApiModelProperty("经销商")
    private String customerName;
    @ZfireField(tbName = "b")
    @ApiModelProperty("物料编码")
    private String materialCode;
    @ZfireField(tbName = "b")
    @ApiModelProperty("产品名称")
    private String materialName;
    @ZfireField(tbName = "b")
    @ApiModelProperty("厂产品编码")
    private String materialOldNumber;
    @ZfireField(tbName = "b")
    @ApiModelProperty("规格型号")
    private String specification;
    @ZfireField(tbName = "b",type = "select",multiple = true,colName = "k3_category_id",frontCode = SysDictConstant.K3_CATEGORY)
    @ApiModelProperty("产品类别")
    private String k3CategoryName;
    @ZfireField(tbName = "b")
    @ApiModelProperty("单位")
    private String unit;
    @ApiModelProperty("文件编号")
    private String fileNo;
    @ZfireField(tbName = "b",type = "select",frontCode = SysDictConstant.WALLET_REBATE)
    @ApiModelProperty("返利钱包名称")
    private String customerWalletName2;
    @ZfireField(tbName = "b",type = "select",frontCode = SysDictConstant.WALLET)
    @ApiModelProperty("现金钱包名称")
    private String customerWalletName;
    @ZfireField(tbName = "b")
    @ApiModelProperty("单价")
    private BigDecimal price;
    @ZfireField(tbName = "b")
    @ApiModelProperty("数量")
    private Integer qty;
    @ZfireField(tbName = "b")
    @ApiModelProperty("实付金额")
    private BigDecimal payAmount;
    @ZfireField(tbName = "b")
    @ApiModelProperty("实际返利金额")
    private BigDecimal payRebateAmount;
    @ZfireField(tbName = "b")
    @ApiModelProperty("格力折扣单价")
    private BigDecimal discAmount;
    @ZfireField(tbName = "b")
    @ApiModelProperty("格力折扣总额")
    private BigDecimal totalDiscAmount;

    @ApiModelProperty("表头业务员")
    private String k3ServiceName;
    @ZfireField(tbName = "b")
    @ApiModelProperty("表体业务员")
    private String serviceName;
    @ApiModelProperty("表头备注")
    private String remark;
    @ApiModelProperty("制表人")
    private String createBy;
    @ApiModelProperty("制表日期")
    private Date createTime;
    @ApiModelProperty("审核人")
    private String examineName;
    @ApiModelProperty("审核日期")
    private Date examineTime;

}
