package com.zfire.mall.manager.bean.reserved;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.zfire.mall.manager.plus.entity.InvoiceApplication;
import com.zfire.mall.manager.plus.entity.ReservedOrder;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author change
 */
@ApiModel
@Data
public class ReservedBean extends ReservedOrder {


    @ApiModelProperty(value = "预留详细单号（关闭传得id）")
    private String itemId;

    @ApiModelProperty(value = "预留单号")
    private String reservedId;

    @ApiModelProperty(value = "关联订单产品id")
    private String orderId;

    @ApiModelProperty(value = "销售订单id")
    private String mainOrderId;

    @ApiModelProperty(value = "预留数量")
    private Integer reservedNum;

    @ApiModelProperty(value = "预留备注")
    private String reservedRemark;

    @ApiModelProperty(value = "订单类型 TRADE=商用 HOME=家用 RETAIL=零售单 RETAIL_POLICY 销售政策单  PERMU_HOME = 置换单家用        PERMU_TRADE 置换商用   PERMU_RETAIL  置换零售   PERMU_RETAIL_POLICY 置换销售政策单")
    private String orderType;

    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "1 执行中  0关闭")
    private Integer status;


    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商编码")
    private String customerNumber;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty(value = "物料规格型号")
    private String specification;

    @ApiModelProperty(value = "单位")
    private String unit;

    @ApiModelProperty(value = "数量")
    private Integer qty;


    @ApiModelProperty(value = "关闭人")
    private String closureBy;

    @ApiModelProperty(value = "关闭时间")
    private Date closureTime;

    @ApiModelProperty(value = "品类id")
    private String mainId;

    @ApiModelProperty(value = "品类名称")
    private String mainName;

    @ApiModelProperty(value = "物料代码")
    private String materialOldNumber;

    @ApiModelProperty(value = "原始预留数量")
    private Integer oldNum;


    @ApiModelProperty(value = "仓库ID")
    private String correspondId;

    @ApiModelProperty(value = "仓库名称")
    private String correspondName;

    @ApiModelProperty(value = "序号")
    private String frequency;
}
