package com.zfire.mall.manager.bean.reserved;

import com.zfire.mall.manager.plus.entity.ReservedOrderItem;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * @author change
 */
@ApiModel
@Data
public class ReservedOrderBean {

    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "经销商编码")
    private String customerNumber;


    @ApiModelProperty(value = "单据日期")
    private Date orderTime;

    @ApiModelProperty(value = "订单类型 TRADE=商用 HOME=家用 RETAIL=零售单 RETAIL_POLICY 销售政策单  PERMU_HOME = 置换单家用        PERMU_TRADE 置换商用   PERMU_RETAIL  置换零售   PERMU_RETAIL_POLICY 置换销售政策单")
    private String orderType;

    @ApiModelProperty(value = "主订单id")
    private String orderId;

    @ApiModelProperty(value = "订单产品id")
    private String mainOrderId;

    @ApiModelProperty(value = "销售类型id")
    private String saleTypeId;


    @ApiModelProperty(value = "销售类型名称")
    private String saleTypeName;

    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "旧物料编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty(value = "物料规格型号")
    private String specification;

    @ApiModelProperty(value = "单位")
    private String unit;

    @ApiModelProperty(value = "数量")
    private Integer qty;

    @ApiModelProperty(value = "可退数量")
    private Integer refundableQty;

    @ApiModelProperty(value = "已退数量")
    private Integer retiredQty;

    @ApiModelProperty(value = "品类")
    private String mainName;

    @ApiModelProperty(value = "品类id")
    private String mainId;

    @ApiModelProperty(value = "可用库存数量")
    private Integer openNumber;

    @ApiModelProperty(value = "业务员id")
    private String serviceId;

    @ApiModelProperty(value = "业务员名称")
    private String serviceName;
}
