package com.zfire.mall.manager.bean.retail;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.List;

@ApiModel
@Data
public class RetailOrderAdd {

    private String id;

    @NotBlank(message = "单据日期不能为空")
    @ApiModelProperty(value = "单据日期",required = true)
    private String theTime;

    @NotBlank(message = "品类id不能为空")
    @ApiModelProperty(value="品类id",required = true)
    private String mainId;

    @NotBlank(message = "品类名称不能为空")
    @ApiModelProperty(value="品类名称",required = true)
    private String mainName;

    @NotBlank(message = "表头备注不能为空")
    @ApiModelProperty(value="表头备注",required = true)
    private String remark;

    @NotNull(message = "产品信息不能为空")
    @ApiModelProperty(value="产品信息",required = true)
    private List<RetailOrderItemBean> retailOrderItemList;

    @ApiModelProperty(value="单据状态 SAVE=保存 WAIT=待审核 OK=通过 FAIL=不通过 CLOSE=已关闭",required = true)
    private String examineStatus;

    @ApiModelProperty(value="类型 1=普通零售  2=销售政策",required = true)
    private Integer type;

    @ApiModelProperty("政策id(当类型为销售政策时必传)")
    private String policyId;

    @ApiModelProperty("业务员id")
    private String k3ServiceId;
    @ApiModelProperty("业务员名称")
    private String k3ServiceName;

    @ApiModelProperty("文件编号")
    private String fileNo;

    @ApiModelProperty(value = "是否计划单 true=是 false=否")
    private Boolean isPlanOrder;

    @ApiModelProperty(value = "仓库ID")
    private String correspondId;

    @ApiModelProperty(value = "仓库名称")
    private String correspondName;

    @ApiModelProperty(value = "是否全部直调 true=是 false=否")
    private Boolean isAllDirect;
}
