package com.zfire.mall.manager.bean.retail;

import com.zfire.mall.manager.enums.IsEnum;
import com.zfire.mall.manager.plus.entity.RetailOrder;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@ApiModel
@Data
public class RetailOrderList  extends RetailOrder {


    @ApiModelProperty(value = "订单商品id")
    private String retailId;
    @ApiModelProperty("物料id")
    private String materialId;
    @ApiModelProperty("物料编号")
    private String materialCode;
    @ApiModelProperty("物料名称")
    private String materialName;
    @ApiModelProperty("旧物料代码")
    private String materialOldNumber;
    @ApiModelProperty("规格型号")
    private String specification;
    @ApiModelProperty("单位")
    private String unit;
    @ApiModelProperty("数量")
    private Integer qty;
    @ApiModelProperty("单价")
    private BigDecimal price;
    @ApiModelProperty("小计总金额")
    private BigDecimal itemTotalAmount;
    @ApiModelProperty("返利钱包名称")
    private String customerWalletName2;
    @ApiModelProperty("现金钱包名称")
    private String customerWalletName;
    @ApiModelProperty("返利钱包比例")
    private BigDecimal rebateRate;
    @ApiModelProperty("返利金额")
    private BigDecimal rebateAmount;
    @ApiModelProperty("是否直调")
    private Boolean isDirectTransfer;
    @ApiModelProperty("直调数量")
    private Integer directTransferQty;
    @ApiModelProperty("提货进度")
    private BigDecimal thjd;
    @ApiModelProperty("销售类型id")
    private String saleTypeId;
    @ApiModelProperty("销售类型名称")
    private String saleTypeName;

    @ApiModelProperty(value = "可退数量")
    private Integer refundableQty;
    @ApiModelProperty(value = "已退数量")
    private Integer retiredQty;
    @ApiModelProperty("已提货数量")
    private Integer hasSendQty;

    @ApiModelProperty("已申请数量")
    private Integer alreadyInvoiceNum;

    @ApiModelProperty("总库存数量")
    private Integer stockAdequate;

    @ApiModelProperty("对应仓库库存数量")
    private Integer stockCorrespond;

    @ApiModelProperty("实际返利金额")
    private BigDecimal payRebateAmount;
    @ApiModelProperty("单个商品的格力折扣金额")
    private BigDecimal discAmount;
    @ApiModelProperty("所有商品的格力折扣金额")
    private BigDecimal totalDiscAmount;
    @ApiModelProperty("实际支付金额")
    private BigDecimal payAmount;

    @ApiModelProperty("表体业务员")
    private String serviceId;
    @ApiModelProperty("表体业务员")
    private String serviceName;

    @ApiModelProperty("表体备注")
    private String itemRemark;
    @ApiModelProperty("存货类别")
    private String k3CategoryName;

    @ApiModelProperty("物料分类")
    private String materialGroupName;


}
