package com.zfire.mall.manager.bean.sale;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import com.zfire.mall.manager.enums.OrderTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author change
 */
@ApiModel
@Data
public class StorageFeeBeanVO {

    @ZfireField(type = "select")
    @ApiModelProperty(value = "订单类型")
    private OrderTypeEnum orderType;

    @ZfireField(colName = "")
    @ApiModelProperty(value = "订单号")
    private String mainOrderId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "明细订单id")
    private String orderId;

    @ApiModelProperty(value = "订单时间")
    private String theTime;

    @ApiModelProperty(value = "订单审核时间")
    private String examineTime;

    @ApiModelProperty("预留单创建时间")
    private Date reservedCreateTime;

    @ApiModelProperty(value = "预留单单号")
    private String reservedId;

    @ApiModelProperty(value = "申请发货单号")
    private String invoiceId;

    @ApiModelProperty(value = "申请发货日期")
    private Date orderTime;

    @ApiModelProperty(value = "申请发货审批人")
    private Date approvalTime;


    @ZfireField(type = "select")
    @ApiModelProperty(value = "单据状态 SAVE=保存 WAIT=待审核 OK=通过 FAIL=不通过 CLOSE=关闭")
    private ExamineStatusEnum salesExamineStatus;

    @ApiModelProperty(value = "审批人")
    private String salesApprovalName;

    @ApiModelProperty(value = "审批时间")
    private Date salesApprovalTime;

    @ApiModelProperty("发货仓库")
    private String correspondName;

    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;


    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty(value = "规格")
    private String specification;


    @ApiModelProperty(value = "订单数量")
    private Integer qty;

    @ApiModelProperty(value = "价税合计")
    private BigDecimal payAmount;


    @ApiModelProperty(value = "折扣额度")
    private BigDecimal payRebateAmount;

    @ApiModelProperty("合计")
    private BigDecimal totalAmount;

    @ApiModelProperty(value = "发货数")
    private Integer refundableQty;

    @ApiModelProperty("未发货数量")
    private Integer sendQty;

    @ApiModelProperty("起算日期")
    private Date startCalculationTime;

    @ApiModelProperty("结算日期")
    private Date endCalculationTime;

    @ApiModelProperty("发货金额")
    private BigDecimal shipmentAmount;

    @ApiModelProperty("计算天数")
    private Integer calculationDays;

    @ApiModelProperty("仓租")
    private BigDecimal warehouseRent;

    @ApiModelProperty("钱包")
    private String customerWalletName;

    @ApiModelProperty("业务员")
    private String serviceName;

    @ApiModelProperty("金蝶部门")
    private String k3OrgNumber;

    @ApiModelProperty("使用单位")
    private String refUseUnit;

    @ApiModelProperty("折扣金额")
    private String totalDiscAmount;


}
