package com.zfire.mall.manager.bean.stock;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import com.zfire.mall.manager.enums.K3CommonStatusEnum;
import com.zfire.mall.manager.enums.OtherOrderTypeEnum;
import com.zfire.mall.manager.plus.entity.KingDeeOtherStockIn;
import com.zfire.mall.manager.plus.entity.KingDeeOtherStockInItem;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author change
 */
@ApiModel
@Data
public class KingDeeOtherStockInVO  {

    @ZfireField(tbName = "kdpso",hide = true)
    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ZfireField(tbName = "kdpso",hide = true)
    @ApiModelProperty(value = "供应链组织id")
    private String supplyOrgId;

    @ZfireField(tbName = "kdpso",hide = true)
    @ApiModelProperty(value = "实体主键")
    private String fId;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "单据编号")
    private String billNo;

    @ZfireField(tbName = "kdpso",hide = true)
    @ApiModelProperty(value = "库存组织")
    private String stockOrgId;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "日期")
    private Date fDate;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "货主类型")
    private String ownerTypeIdHead;

    @ZfireField(tbName = "kdpso",hide = true)
    @ApiModelProperty(value = "供应商")
    private String supplierId;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "状态")
    private ExamineStatusEnum cancelStatus;

    @ZfireField(tbName = "kdpso",hide = true)
    @ApiModelProperty(value = "仓库")
    private String abcdBase;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "审核人")
    private String approverId;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "审核日期")
    private Date approveDate;

    @ZfireField(tbName = "kdpso")
    @ApiModelProperty(value = "备注")
    private String note;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ZfireField(tbName = "kdpsoi",hide = true)
    @ApiModelProperty(value = "收货仓库")
    private String stockId;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "备注")
    private String entryNote;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "实收数量")
    private BigDecimal qty;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "仓库名称")
    private String stockName;

}
