package com.zfire.mall.manager.bean.stock;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.ExamineStatusEnum;
import com.zfire.mall.manager.enums.K3CommonStatusEnum;
import com.zfire.mall.manager.enums.OtherOrderTypeEnum;
import com.zfire.mall.manager.plus.entity.KingDeeOtherStockOut;
import com.zfire.mall.manager.plus.entity.KingDeeOtherStockOutItem;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author change
 */
@ApiModel
@Data
@ZfireField(tbName = "kdpso")
public class KingDeeOtherStockOutVO   {

    @ZfireField(hide = true)
    private String id;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "供应链组织id")
    private String supplyOrgId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "实体主键")
    private String fId;

    @ApiModelProperty(value = "单据编号")
    private String billNo;

    @ApiModelProperty(value = "入库日期")
    private Date fDate;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "库存组织")
    private String stockOrgId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "客户")
    private String custId;

    @ApiModelProperty(value = "状态")
    private ExamineStatusEnum cancelStatus;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "仓库")
    private String abcdBase;

    @ApiModelProperty(value = "审核人")
    private String approverId;

    @ApiModelProperty(value = "审核日期")
    private Date approveDate;


    @ApiModelProperty(value = "备注")
    private String note;


    @ApiModelProperty(value = "方向")
    private OtherOrderTypeEnum stockDirect;


    @ZfireField(hide = true,tbName = "kdpsoi")
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "物料名称")
    private String materialName;


    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "备注")
    private String entryNote;

    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "实发数量")
    private BigDecimal qty;


    @ZfireField(tbName = "kdpsoi")
    @ApiModelProperty(value = "仓库名称")
    private String stockName;




}
