package com.zfire.mall.manager.bean.stock;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.IsEnum;
import com.zfire.mall.manager.enums.OrderFullStatusEnum;
import com.zfire.mall.manager.enums.OrderTypeEnum;
import com.zfire.mall.manager.plus.entity.OrderFullCost;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author change
 */
@ApiModel
@Data
@ZfireField(tbName = "a")
public class OrderFullCostDayVO {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "日账单id")
    private String orderFullCostId;

    @ApiModelProperty(value = "所属年份")
    private String yearTime;

    @ApiModelProperty(value = "所属月份")
    private String monthTime;

    @ApiModelProperty(value = "账单状态")
    private OrderFullStatusEnum status;

    @ApiModelProperty(value = "订单类型")
    private OrderTypeEnum orderType;

    @ApiModelProperty(value = "订单号")
    private String orderNo;

    @ApiModelProperty(value = "订单时间")
    private Date orderTime;

    @ApiModelProperty(value = "订单审核时间")
    private Date examineTime;

    @ApiModelProperty(value = "经销商编号")
    private String customerNumber;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "使用单位")
    private String refUseUnit;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "金蝶物料id")
    private String materialId;

    @ApiModelProperty(value = "旧物料编码")
    private String materialOldNumber;

    @ApiModelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty(value = "物料规格型号")
    private String specification;

    @ApiModelProperty(value = "仓储计算数量")
    private String orderNum;

    @ApiModelProperty(value = "金额")
    private BigDecimal payAmount;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商现金钱包id")
    private String customerWalletId;

    @ApiModelProperty(value = "经销商现金钱包名称")
    private String customerWalletName;

    @ApiModelProperty(value = "经销商现金钱包编码")
    private String customerWalletNumber;

    @ApiModelProperty(value = "货满起算日期")
    private String fullStartTime;

    @ApiModelProperty(value = "货满结算日期")
    private String fullEndTime;

    @ApiModelProperty(value = "货满天数")
    private Integer fullNum;

    @ApiModelProperty(value = "实际逾期天数")
    private Integer overdueNum;

    @ApiModelProperty(value = "仓租金额")
    private BigDecimal fullCost;


    @ApiModelProperty(value = "创建时间")
    private Date createTime;


    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "备注")
    private String note;

    @ApiModelProperty(value = "存货类别")
    private String k3CategoryName;

}
