package com.zfire.mall.manager.bean.stock;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.FrontCodeConstant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @author change
 */
@ApiModel
@Data
public class StockBeanToCostPrice {


    @ZfireField(hide = true,tbName = "scp")
    @ApiModelProperty(value = "仓库ID")
    private String correspondId;

    @ZfireField(tbName = "sc",colName = "id",multiple = true,frontCode = FrontCodeConstant.STOCK,type = "select")
    @ApiModelProperty(value = "仓库名称")
    private String correspondName;

    @ZfireField(tbName = "kdm",multiple = true,colName = "category_id",frontCode = FrontCodeConstant.CATEGORY,type = "select")
    @ApiModelProperty(value = "存货类别")
    private String categoryName;

    @ZfireField(hide = true,tbName = "kdm",colName = "id")
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ZfireField(tbName = "kdm",colName = "number")
    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ZfireField(tbName = "kdm",colName = "old_number")
    @ApiModelProperty(value = "产品编码")
    private String materialOldNumber;

    @ZfireField(tbName = "kdm",colName = "name")
    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ZfireField(tbName = "kdm",colName = "specification")
    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ZfireField(isQuery = false)
    @ApiModelProperty("可用数量")
    private Integer stockAdequate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "开单未提数量")
    private Integer num;

    @ZfireField(tbName = "s",colName = "stock_qty",isQuery = false)
    @ApiModelProperty("结存数量")
    private Integer balanceNumber;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "经销商预留库存")
    private Integer reservedNum;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商暂扣库存")
    private Integer temporaryNum;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "产品大类")
    private String mainName;

    @ZfireField(hide = true)
    @ApiModelProperty("可开数量")
    private Integer openNumber;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "总库存数量")
    private Integer stockQty;

    @ApiModelProperty(value = "成本单价")
    private BigDecimal costPrice;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "金额")
    private BigDecimal costPriceAll;



}
