package com.zfire.mall.manager.bean.stock;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.annotation.ZfireField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 物料库存
 * </p>
 *
 * @author gejiang
 * @since 2022-09-03
 */
@Data
public class StockCustomerReserved {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ZfireField(tbName = "roi")
    @ApiModelProperty(value = "经销商名字")
    private String customerName;
    @ZfireField(tbName = "roi")
    @ApiModelProperty(value = "经销商编码")
    private String customerNumber;
    @ZfireField(tbName = "kdm")
    @ApiModelProperty(value = "存货类别名称")
    private String categoryName;
    @ZfireField(tbName = "roi",colName = "material_code")
    @ApiModelProperty(value = "物料编码")
    private String materialNumber;
    @ZfireField(tbName = "roi")
    @ApiModelProperty(value = "产品编码")
    private String materialOldNumber;
    @ZfireField(tbName = "roi")
    @ApiModelProperty(value = "产品名称")
    private String materialName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ZfireField(tbName = "roi")
    @ApiModelProperty(value = "规格型号")
    private String specification;
    @ZfireField(tbName = "roi")
    @ApiModelProperty(value = "单位")
    private String unit;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "经销商预留库存")
    private Integer reservedNum;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商暂扣库存")
    private Integer temporaryNum;









}
