package com.zfire.mall.manager.bean.stock;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.constant.FrontCodeConstant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author change
 */
@ApiModel
@Data
public class StockVO {

    @ZfireField(tbName = "kdm",colName = "category_id",frontCode = FrontCodeConstant.CATEGORY,type = "select",multiple = true)
    @ApiModelProperty(value = "存货类别名称")
    private String categoryName;

    @ZfireField(tbName = "kdm")
    @ApiModelProperty(value = "物料分组")
    private String materialGroupName;

    @ZfireField(hide = true,tbName = "kdm",colName = "id")
    @ApiModelProperty(value = "物料id")
    private String materialId;

    @ZfireField(tbName = "kdm",colName = "number")
    @ApiModelProperty(value = "物料编码")
    private String materialNumber;

    @ZfireField(tbName = "kdm",colName = "old_number")
    @ApiModelProperty(value = "厂产品代码")
    private String materialOldNumber;

    @ZfireField(tbName = "kdm",colName = "name")
    @ApiModelProperty(value = "物料名称")
    private String materialName;

    @ZfireField(tbName = "kdm",colName = "specification")
    @ApiModelProperty(value = "规格型号")
    private String specification;

    @ZfireField(tbName = "kdm",colName = "base_unit_id")
    @ApiModelProperty(value = "单位")
    private String baseUnitId;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "总库存数量")
    private Integer stockQty;

    @ZfireField(isQuery = false)
    @ApiModelProperty("可用数量")
    private Integer stockAdequate;

    @ZfireField(isQuery = false)
    @ApiModelProperty("可开数量")
    private Integer openNumber;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "经销商预留库存")
    private Integer reservedNum;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "经销商暂扣库存")
    private Integer temporaryNum;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "开单未提数量")
    private Integer num;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "产品大类")
    private String mainName;

/*
    @ZfireField(isShow = false,isQuery = true,tbName = "scp",colName = "correspond_id",frontCode = FrontCodeConstant.STOCK_NO,type = "select",multiple = true)
    @ApiModelProperty(value = "仓库名称")
    private String correspondId;*/


}
