package com.zfire.mall.manager.bean.supplier;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.IsEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 金蝶仓库
 * </p>
 *
 * @author gejiang
 * @since 2023-03-06
 */
@ApiModel
@Data
public class KingDeeStockVO  {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "仓库编码")
    private String id;

    @ApiModelProperty(value = "仓库编码")
    private String number;

    @ApiModelProperty(value = "仓库名称")
    private String name;

    @ApiModelProperty(value = "仓库负责人")
    private String principalName;

    @ApiModelProperty(value = "仓库属性")
    private String stockProperty;

    @ZfireField(type = "select")
    @ApiModelProperty(value = "允许即时库存负库存")
    private IsEnum allowMinusQty;

    @ZfireField(type = "select")
    @ApiModelProperty(value = "启用仓库管理")
    private IsEnum openLocation;

    @ZfireField(type = "select")
    @ApiModelProperty(value = "不参与可发量统计")
    private IsEnum notExpQty;

    @ZfireField(type = "select")
    @ApiModelProperty(value = "参与预警")
    private IsEnum availableAlert;




}
