package com.zfire.mall.manager.bean.supplier;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.K3CommonStatusEnum;
import com.zfire.mall.manager.plus.entity.KingDeeSupplier;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 金蝶供应商
 * </p>
 *
 * @author gejiang
 * @since 2023-03-06
 */
@ApiModel
@Data
public class KingDeeSupplierVO   {


    @ZfireField(hide = true)
    @ApiModelProperty(value = "供应商编码")
    private String id;

    @ApiModelProperty(value = "供应商编码")
    private String number;

    @ApiModelProperty(value = "供应商名称")
    private String name;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "使用组织")
    private String useOrgId;

    @ApiModelProperty(value = "使用组织编码")
    private String useOrgNumber;

    @ApiModelProperty(value = "使用组织名称")
    private String useOrgName;


    @ApiModelProperty(value = "禁用状态")
    private K3CommonStatusEnum forbidStatus;


    @ZfireField(hide = true)
    @ApiModelProperty(value = "同步时间")
    private Date syncTime;

    @ApiModelProperty(value = "简称")
    private String shortName;

    @ApiModelProperty(value = "供应商分组")
    private String groupName;




}
