package com.zfire.mall.manager.bean.trade;

import com.zfire.mall.manager.annotation.ZfireField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
public class DataLoginOrderVO {

    @ZfireField(isShow = false)
    @ApiModelProperty(value = "登录时间")
    private Date createTime;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "家装登录总数")
    private Integer homeCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "家装登录成功数量")
    private Integer homeSuccessCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "家装签约数量")
    private Integer homeSignCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "家装签约率")
    private BigDecimal homeSignRate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "家装丢单数量")
    private Integer homeLossCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "家装丢单率")
    private BigDecimal homeLossRate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程登录总数")
    private Integer workCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程登录成功数量")
    private Integer workSuccessCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程签约数量")
    private Integer workSignCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程签约率")
    private BigDecimal workSignRate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程丢单数量")
    private Integer workLossCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程丢单率")
    private BigDecimal workLossRate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "跨区登录总数")
    private Integer spanCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "跨区登录成功数量")
    private Integer spanSuccessCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "跨区签约数量")
    private Integer spanSignCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "跨区签约率")
    private BigDecimal spanSignRate;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "跨区丢单数量")
    private Integer spanLossCount;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "跨区丢单率")
    private BigDecimal spanLossRate;
}
