package com.zfire.mall.manager.bean.trade;

import com.zfire.mall.manager.annotation.ZfireField;
import com.zfire.mall.manager.enums.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel
@ZfireField(tbName = "a")
public class HomeLoginOrderVO {

    @ZfireField(hide = true)
    @ApiModelProperty(value = "id")
    private String id;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "部门id")
    private String adminWebsitId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "用户id")
    private String adminUserId;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "工程类型")
    private TradeLoginOrderTypeEnum orderType;

//    @ApiModelProperty(value = "销售公司名称")
//    private String salesCompanyName;

    @ZfireField(isShow = false)
    @ApiModelProperty(value = "项目所在区域")
    private TradeProjectAreaEnum projectArea;

    @ApiModelProperty(value = "项目编号")
    private String projectNo;

    @ApiModelProperty(value = "工程项目名称")
    private String projectName;

    @ZfireField(type = "date")
    @ApiModelProperty(value = "登录时间")
    private Date submitTime;

    @ZfireField(type = "date")
    @ApiModelProperty(value = "更新时间")
    private Date orderUpdateTime;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "跟进人")
    private String serviceId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "业务员编号")
    private String serviceNumber;

    @ApiModelProperty(value = "业务员")
    private String serviceName;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "经销商编码")
    private String customerNumber;

//    @ApiModelProperty(value = "经销商联系人")
//    private String customerLinkName;
//
//    @ApiModelProperty(value = "经销商联系电话")
//    private String customerLinkMobile;
//
//    @ApiModelProperty(value = "经销商办公地址")
//    private String customerAddress;
//
//    @ApiModelProperty(value = "跟进经销商")
//    private String followCustomer;
//
//    @ApiModelProperty(value = "跟进经销商电话")
//    private String followCustomerMobile;
//
//    @ApiModelProperty(value = "工程联系人")
//    private String enginLinkName;
//
//    @ApiModelProperty(value = "工程联系电话")
//    private String enginLinkMobile;

    @ApiModelProperty(value = "机组类型")
    private TradeMachineTypeEnum machineType;

    @ApiModelProperty(value = "工程地址")
    private String joinAddress;

//    @ApiModelProperty(value = "项目类别")
//    private TradeLoginCategoryEnum projectCategory;
//
//    @ApiModelProperty(value = "类型")
//    private TradeLoginTypeEnum type;
//
//    @ApiModelProperty(value = "建筑面积")
//    private String extent;
//
//    @ApiModelProperty(value = "空调使用面积")
//    private String useExtent;
//
//    @ApiModelProperty(value = "项目所在行业分类")
//    private String tradeParentName;
//
//    @ApiModelProperty(value = "行业细分")
//    private String tradeName;
//
//    @ApiModelProperty(value = "项目性质")
//    private String projectMent;
//
//    @ApiModelProperty(value = "成功机率")
//    private TradeSuccessRateEnum successRate;
//
//    @ApiModelProperty(value = "预计签定合同日期")
//    private Date preSignDate;
//
    @ZfireField(isShow = false)
    @ApiModelProperty(value = "预计设备金额")
    private BigDecimal preDeviceAmount;

    @ApiModelProperty(value = "跟进状态")
    private TradeFollowStatusEnum status;

//    @ApiModelProperty(value = "备注")
//    private String remark;
//
//    @ApiModelProperty(value = "其他相关信息")
//    private String otherInfo;

    @ApiModelProperty(value = "单据状态")
    private TradeOrderStatusEnum orderStatus;

    @ApiModelProperty(value = "登录状态")
    private TradeLoginStatusEnum loginStatus;

    @ApiModelProperty(value = "审核备注")
    private String note;

    @ZfireField(hide = true)
    @ApiModelProperty(value = "是否申请修改 true=是 false=否")
    private BigDecimal isApplyUpdate;

//    @ApiModelProperty(value = "创建人")
//    private String createBy;
//
//    @ApiModelProperty(value = "更新人")
//    private String updateBy;
//
//    @ApiModelProperty(value = "提交人")
//    private String submitBy;
//
//    @ApiModelProperty(value = "提交时间")
//    private Date submitTime;
//
//    @ApiModelProperty(value = "审核人")
//    private String confirmBy;
//
//    @ApiModelProperty(value = "审核时间")
//    private Date confirmTime;
}
