package com.zfire.mall.manager.bean.trade;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class TradeOrderImportBean {
    @ApiModelProperty(value = "单据类型 WORK=工装  HOME=家装")
    private String orderType;

    @ApiModelProperty(value = "是否跨区 true=是 false=否")
    private String isSpanStr;

    @ApiModelProperty(value = "是否跨区 true=是 false=否")
    private Boolean isSpan;

    @ApiModelProperty(value = "销售公司名称")
    private String salesCompanyName;

    @ApiModelProperty(value = "项目所在区域")
    private String projectArea;

    @ApiModelProperty(value = "项目编号")
    private String projectNo;

    @ApiModelProperty(value = "跟进人")
    private String serviceId;

    @ApiModelProperty(value = "业务员编码")
    private String serviceNumber;

    @ApiModelProperty(value = "业务员名称")
    private String serviceName;

    @ApiModelProperty(value = "甲方id")
    private String partyAId;

    @ApiModelProperty(value = "甲方名称")
    private String partyA;

    @ApiModelProperty(value = "经销商id")
    private String customerId;

    @ApiModelProperty(value = "经销商编码")
    private String customerNumber;

    @ApiModelProperty(value = "经销商名称")
    private String customerName;

    @ApiModelProperty(value = "经销商联系人")
    private String customerLinkName;

    @ApiModelProperty(value = "经销商联系电话")
    private String customerLinkMobile;

    @ApiModelProperty(value = "经销商办公地址")
    private String customerAddress;

    @ApiModelProperty(value = "跟进经销商")
    private String followCustomer;

    @ApiModelProperty(value = "跟进经销商电话")
    private String followCustomerMobile;

    @ApiModelProperty(value = "工程项目名称")
    private String projectName;

    @ApiModelProperty(value = "单选工程项目名称 AREA=小区 SELF=自建房 VILLA=别墅")
    private String homeProjectNameRadio;

    @ApiModelProperty(value = "工程项目名称小区")
    private String homeProjectNameArea;

    @ApiModelProperty(value = "工程项目名称座")
    private String homeProjectNameSeat;

    @ApiModelProperty(value = "工程项目名称号")
    private String homeProjectNameNumber;

    @ApiModelProperty(value = "工程联系人")
    private String enginLinkName;

    @ApiModelProperty(value = "工程联系电话")
    private String enginLinkMobile;

    @ApiModelProperty(value = "省")
    private String provinceId;

    @ApiModelProperty(value = "市")
    private String cityId;

    @ApiModelProperty(value = "区")
    private String areaId;

    @ApiModelProperty(value = "街道")
    private String streetId;

    @ApiModelProperty(value = "详细地址")
    private String address;

    @ApiModelProperty(value = "拼接地址")
    private String joinAddress;

    @ApiModelProperty(value = "纬度")
    private String lat;

    @ApiModelProperty(value = "经度")
    private String lnt;

    @ApiModelProperty(value = "项目类别 STRATEGY=战略协议下属子项目 COMMON=普通单体项目  RAIL=铁路干线项目")
    private String projectCategory;

    @ApiModelProperty(value = "类型 DRAW=图纸 MESSAGE=竞品资料 SITE_IMG=现场图片 LICENSE=营业执照 OTHER=其他照片")
    private String type;

    @ApiModelProperty(value = "建筑面积")
    private String extent;

    @ApiModelProperty(value = "空调使用面积")
    private String useExtent;

    @ApiModelProperty(value = "项目所在行业分类")
    private String tradeParentId;

    @ApiModelProperty(value = "项目所在行业分类名称")
    private String tradeParentName;

    @ApiModelProperty(value = "行业细分")
    private String tradeId;

    @ApiModelProperty(value = "行业细分名称")
    private String tradeName;

    @ApiModelProperty(value = "项目性质")
    private String projectMent;

    @ApiModelProperty(value = "机组类型")
    private String machineType;

    @ApiModelProperty(value = "成功机率")
    private String successRate;

    @ApiModelProperty(value = "预计签定合同日期")
    private Date preSignDate;

    @ApiModelProperty(value = "预计设备金额")
    private BigDecimal preDeviceAmount;

    @ApiModelProperty(value = "工程跟进状态 ING=跟进中 LOSS=已丢单 SIGN=签订合同")
    private String status;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "其他相关信息")
    private String otherInfo;

    @ApiModelProperty(value = "订单状态 SAVE=保存 WAIT=待审核 OK=登录成功 FAIL=登录不成功 RETURN=返回")
    private String orderStatus;

    @ApiModelProperty(value = "登录状态 OK=登录成功 FAIL=登录不成功 REJECT=驳回")
    private String loginStatus;

    @ApiModelProperty(value = "登录成功项目")
    private String successLoginProject;

    @ApiModelProperty(value = "登录成功业务员编号")
    private String successServiceNumber;

    @ApiModelProperty(value = "登录成功业务员名称")
    private String successServiceName;

    @ApiModelProperty(value = "登录成功经销商编码")
    private String successCustomerNumber;

    @ApiModelProperty(value = "登录成功经销商名称")
    private String successCustomerName;

    @ApiModelProperty(value = "审核备注")
    private String examineNote;

    @ApiModelProperty(value = "审核备注补充")
    private String note;

    @ApiModelProperty(value = "共同跟进项目编号")
    private String commonFollowProject;

    @ApiModelProperty(value = "申请修改人id")
    private String applyUpdateBy;

    @ApiModelProperty(value = "申请修改人")
    private String applyUpdateName;

    @ApiModelProperty(value = "申请修改人公司id")
    private String applyUpdateCompanyId;

    @ApiModelProperty(value = "申请修改人公司")
    private String applyUpdateCompanyName;

    @ApiModelProperty(value = "是否申请修改 true=是 false=否")
    private Boolean isApplyUpdate;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建人名称")
    private String createName;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    private String updateBy;

    @ApiModelProperty(value = "更新人名称")
    private String updateName;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "更新时间")
    private Date orderUpdateTime;

    @ApiModelProperty(value = "提交人")
    private String submitBy;

    @ApiModelProperty(value = "提交人名称")
    private String submitName;

    @ApiModelProperty(value = "提交时间")
    private Date submitTime;

    @ApiModelProperty(value = "审核人")
    private String confirmBy;

    @ApiModelProperty(value = "审核人名称")
    private String confirmName;

    @ApiModelProperty(value = "审核时间")
    private Date confirmTime;

    @ApiModelProperty(value = "旧单附件url")
    private String oldFileUrl;

    @ApiModelProperty(value = "旧单附件名称")
    private String oldFileName;

    @ApiModelProperty(value = "登录机型")
    private String loginMachine;
}
