package com.zfire.mall.manager.controller.k3.v2;

import cn.hutool.core.lang.TypeReference;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zfire.mall.manager.annotation.ZfireList;
import com.zfire.mall.manager.bean.k3.v2.KingDeeCategoryVO;
import com.zfire.mall.manager.exception.RemoteServiceException;
import com.zfire.mall.manager.helper.ResponseHelper;
import com.zfire.mall.manager.logic.k3.v2.K3CategoryV2Logic;
import com.zfire.mall.manager.zfire.bean.ZfireParamBean;
import com.zfire.mall.manager.zfire.util.FieldUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Slf4j
@RestController
@Api(value = "金蝶存货类别v2", tags ={"金蝶存货类别v2"} )
@RequestMapping(value = "/v2/k3/category", produces = "application/json; charset=utf-8")
public class K3CategoryV2Controller {

    @Resource
    K3CategoryV2Logic k3CategoryV2Logic;

    @ZfireList
    @ApiOperation(value = "存货类别-列表")
    @PostMapping("/list")
    public ResponseHelper<IPage<KingDeeCategoryVO>> v2ListPage(
            @RequestBody ZfireParamBean zfireParamBean
    ) throws RemoteServiceException {
        IPage<KingDeeCategoryVO> list = k3CategoryV2Logic.v2ListPage(zfireParamBean);
        return ResponseHelper.success(list, new TypeReference<KingDeeCategoryVO>() {});
    }

    @PostMapping("/list/export")
    @ApiOperation("存货类别-导出")
    public void v2ListPageExport(
            @RequestBody ZfireParamBean zfireParamBean,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        //1.组装查询条件
        ZfireParamBean zfireParam = FieldUtils.supplyParam(zfireParamBean);
        //2.查询要导出的内容
        IPage<KingDeeCategoryVO> list = k3CategoryV2Logic.v2ListPage(zfireParamBean);
        //3.导出
        FieldUtils.exportData(list.getRecords(),zfireParam.getExportFields(),request,response);
    }
}
