package com.zfire.mall.manager.controller.k3.v2;


import cn.hutool.core.lang.TypeReference;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zfire.mall.manager.annotation.ZfireList;
import com.zfire.mall.manager.bean.k3.v2.KingTransferVO;
import com.zfire.mall.manager.helper.ResponseHelper;
import com.zfire.mall.manager.logic.k3.v2.K3TransferV2Logic;
import com.zfire.mall.manager.zfire.bean.ZfireParamBean;
import com.zfire.mall.manager.zfire.util.FieldUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author CHANGE
 */
@Slf4j
@RestController
@Api(value = "调拨单管理v2", tags ={"调拨单管理v2"} )
@RequestMapping(value = "/v2/transfer", produces = "application/json; charset=utf-8")
public class K3TransferV2Controller {

    @Resource
    K3TransferV2Logic k3TransferV2Logic;

    @ZfireList
    @ApiOperation(value = "调拨单-列表")
    @PostMapping("/list")
    public ResponseHelper<IPage<KingTransferVO>> v2ListPage(
            @RequestBody ZfireParamBean zfireParamBean
    ) throws Exception {
        IPage<KingTransferVO> page = k3TransferV2Logic.v2ListPage(zfireParamBean);
        return ResponseHelper.success(page, new TypeReference<KingTransferVO>() {});
    }

    @PostMapping("/list/export")
    @ApiOperation("调拨单-导出")
    public void v2ListPageExport(
            @RequestBody ZfireParamBean zfireParamBean,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        //1.组装查询条件
        ZfireParamBean zfireParam = FieldUtils.supplyParam(zfireParamBean);
        //2.查询要导出的内容
        IPage<KingTransferVO> list = k3TransferV2Logic.v2ListPage(zfireParamBean);
        //3.导出
        FieldUtils.exportData(list.getRecords(),zfireParam.getExportFields(),request,response);
    }
}
