package com.zfire.mall.manager.controller.manage.v2.product.price;

import cn.hutool.core.lang.TypeReference;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zfire.mall.manager.annotation.ZfireList;
import com.zfire.mall.manager.bean.manage.v2.product.price.ProductPriceVO;
import com.zfire.mall.manager.exception.RemoteServiceException;
import com.zfire.mall.manager.helper.ResponseHelper;
import com.zfire.mall.manager.logic.manage.v2.product.price.ProductPriceV2Logic;
import com.zfire.mall.manager.zfire.bean.ZfireParamBean;
import com.zfire.mall.manager.zfire.util.FieldUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Slf4j
@RestController
@Api(value = "产品价格列表v2", tags ={"产品价格列表v2"} )
@RequestMapping(value = "/v2/product-price", produces = "application/json; charset=utf-8")
public class ProductPriceV2Controller {

    @Resource
    ProductPriceV2Logic productPriceV2Logic;

    @ZfireList
    @ApiOperation(value = "产品调价单-列表")
    @PostMapping("/list")
    public ResponseHelper<IPage<ProductPriceVO>> v2ListPage(
            @RequestBody ZfireParamBean zfireParamBean
    ) throws RemoteServiceException {
        IPage<ProductPriceVO> list = productPriceV2Logic.v2ListPage(zfireParamBean);
        return ResponseHelper.success(list, new TypeReference<ProductPriceVO>() {});
    }

    @PostMapping("/list/export")
    @ApiOperation("产品调价单-导出")
    public void v2ListPageExport(
            @RequestBody ZfireParamBean zfireParamBean,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        //1.组装查询条件
        ZfireParamBean zfireParam = FieldUtils.supplyParam(zfireParamBean);
        //2.查询要导出的内容
        IPage<ProductPriceVO> list = productPriceV2Logic.v2ListPage(zfireParamBean);
        //3.导出
        FieldUtils.exportData(list.getRecords(),zfireParam.getExportFields(),request,response);
    }
}
